/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 9 "src/asm/parser.y"

#include <ctype.h>
#include <errno.h>
#include <inttypes.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "asm/charmap.h"
#include "asm/fixpoint.h"
#include "asm/format.h"
#include "asm/fstack.h"
#include "asm/lexer.h"
#include "asm/macro.h"
#include "asm/main.h"
#include "asm/opt.h"
#include "asm/output.h"
#include "asm/rpn.h"
#include "asm/section.h"
#include "asm/symbol.h"
#include "asm/util.h"
#include "asm/warning.h"

#include "extern/utf8decoder.h"

#include "linkdefs.h"
#include "platform.h" // strncasecmp, strdup

static struct CaptureBody captureBody; /* Captures a REPT/FOR or MACRO */

static void upperstring(char *dest, char const *src)
{
	while (*src)
		*dest++ = toupper(*src++);
	*dest = '\0';
}

static void lowerstring(char *dest, char const *src)
{
	while (*src)
		*dest++ = tolower(*src++);
	*dest = '\0';
}

static uint32_t str2int2(uint8_t *s, uint32_t length)
{
	if (length > 4)
		warning(WARNING_NUMERIC_STRING_1,
			"Treating string as a number ignores first %" PRIu32 " character%s\n",
			length - 4, length == 5 ? "" : "s");
	else if (length > 1)
		warning(WARNING_NUMERIC_STRING_2,
			"Treating %" PRIu32 "-character string as a number\n", length);

	uint32_t r = 0;

	for (uint32_t i = length < 4 ? 0 : length - 4; i < length; i++) {
		r <<= 8;
		r |= s[i];
	}

	return r;
}

static const char *strrstr(char const *s1, char const *s2)
{
	size_t len1 = strlen(s1);
	size_t len2 = strlen(s2);

	if (len2 > len1)
		return NULL;

	for (char const *p = s1 + len1 - len2; p >= s1; p--)
		if (!strncmp(p, s2, len2))
			return p;

	return NULL;
}

static void errorInvalidUTF8Byte(uint8_t byte, char const *functionName)
{
	error("%s: Invalid UTF-8 byte 0x%02hhX\n", functionName, byte);
}

static size_t strlenUTF8(char const *s)
{
	size_t len = 0;
	uint32_t state = 0;

	for (uint32_t codep = 0; *s; s++) {
		uint8_t byte = *s;

		switch (decode(&state, &codep, byte)) {
		case 1:
			errorInvalidUTF8Byte(byte, "STRLEN");
			state = 0;
			/* fallthrough */
		case 0:
			len++;
			break;
		}
	}

	/* Check for partial code point. */
	if (state != 0)
		error("STRLEN: Incomplete UTF-8 character\n");

	return len;
}

static void strsubUTF8(char *dest, size_t destLen, char const *src, uint32_t pos, uint32_t len)
{
	size_t srcIndex = 0;
	size_t destIndex = 0;
	uint32_t state = 0;
	uint32_t codep = 0;
	uint32_t curLen = 0;
	uint32_t curPos = 1;

	/* Advance to starting position in source string. */
	while (src[srcIndex] && curPos < pos) {
		switch (decode(&state, &codep, src[srcIndex])) {
		case 1:
			errorInvalidUTF8Byte(src[srcIndex], "STRSUB");
			state = 0;
			/* fallthrough */
		case 0:
			curPos++;
			break;
		}
		srcIndex++;
	}

	/*
	 * A position 1 past the end of the string is allowed, but will trigger the
	 * "Length too big" warning below if the length is nonzero.
	 */
	if (!src[srcIndex] && pos > curPos)
		warning(WARNING_BUILTIN_ARG,
			"STRSUB: Position %" PRIu32 " is past the end of the string\n", pos);

	/* Copy from source to destination. */
	while (src[srcIndex] && destIndex < destLen - 1 && curLen < len) {
		switch (decode(&state, &codep, src[srcIndex])) {
		case 1:
			errorInvalidUTF8Byte(src[srcIndex], "STRSUB");
			state = 0;
			/* fallthrough */
		case 0:
			curLen++;
			break;
		}
		dest[destIndex++] = src[srcIndex++];
	}

	if (curLen < len)
		warning(WARNING_BUILTIN_ARG, "STRSUB: Length too big: %" PRIu32 "\n", len);

	/* Check for partial code point. */
	if (state != 0)
		error("STRSUB: Incomplete UTF-8 character\n");

	dest[destIndex] = '\0';
}

static size_t charlenUTF8(char const *s)
{
	size_t len;

	for (len = 0; charmap_ConvertNext(&s, NULL); len++)
		;

	return len;
}

static void charsubUTF8(char *dest, char const *src, uint32_t pos)
{
	size_t charLen = 1;

	/* Advance to starting position in source string. */
	for (uint32_t curPos = 1; charLen && curPos < pos; curPos++)
		charLen = charmap_ConvertNext(&src, NULL);

	char const *start = src;

	if (!charmap_ConvertNext(&src, NULL))
		warning(WARNING_BUILTIN_ARG,
			"CHARSUB: Position %" PRIu32 " is past the end of the string\n", pos);

	/* Copy from source to destination. */
	memcpy(dest, start, src - start);

	dest[src - start] = '\0';
}

static uint32_t adjustNegativePos(int32_t pos, size_t len, char const *functionName)
{
	/*
	 * STRSUB and CHARSUB adjust negative `pos` arguments the same way,
	 * such that position -1 is the last character of a string.
	 */
	if (pos < 0)
		pos += len + 1;
	if (pos < 1) {
		warning(WARNING_BUILTIN_ARG, "%s: Position starts at 1\n", functionName);
		pos = 1;
	}
	return (uint32_t)pos;
}

static void strrpl(char *dest, size_t destLen, char const *src, char const *old, char const *new)
{
	size_t oldLen = strlen(old);
	size_t newLen = strlen(new);
	size_t i = 0;

	if (!oldLen) {
		warning(WARNING_EMPTY_STRRPL, "STRRPL: Cannot replace an empty string\n");
		strcpy(dest, src);
		return;
	}

	for (char const *next = strstr(src, old); next && *next; next = strstr(src, old)) {
		// Copy anything before the substring to replace
		unsigned int lenBefore = next - src;

		memcpy(dest + i, src, lenBefore < destLen - i ? lenBefore : destLen - i);
		i += next - src;
		if (i >= destLen)
			break;

		// Copy the replacement substring
		memcpy(dest + i, new, newLen < destLen - i ? newLen : destLen - i);
		i += newLen;
		if (i >= destLen)
			break;

		src = next + oldLen;
	}

	if (i < destLen) {
		size_t srcLen = strlen(src);

		// Copy anything after the last replaced substring
		memcpy(dest + i, src, srcLen < destLen - i ? srcLen : destLen - i);
		i += srcLen;
	}

	if (i >= destLen) {
		warning(WARNING_LONG_STR, "STRRPL: String too long, got truncated\n");
		i = destLen - 1;
	}
	dest[i] = '\0';
}

static void initStrFmtArgList(struct StrFmtArgList *args)
{
	args->nbArgs = 0;
	args->capacity = INITIAL_STRFMT_ARG_SIZE;
	args->args = malloc(args->capacity * sizeof(*args->args));
	if (!args->args)
		fatalerror("Failed to allocate memory for STRFMT arg list: %s\n",
			   strerror(errno));
}

static size_t nextStrFmtArgListIndex(struct StrFmtArgList *args)
{
	if (args->nbArgs == args->capacity) {
		args->capacity = (args->capacity + 1) * 2;
		args->args = realloc(args->args, args->capacity * sizeof(*args->args));
		if (!args->args)
			fatalerror("realloc error while resizing STRFMT arg list: %s\n",
				   strerror(errno));
	}
	return args->nbArgs++;
}

static void freeStrFmtArgList(struct StrFmtArgList *args)
{
	free(args->format);
	for (size_t i = 0; i < args->nbArgs; i++)
		if (!args->args[i].isNumeric)
			free(args->args[i].string);
	free(args->args);
}

static void strfmt(char *dest, size_t destLen, char const *fmt, size_t nbArgs, struct StrFmtArg *args)
{
	size_t a = 0;
	size_t i = 0;

	while (i < destLen) {
		int c = *fmt++;

		if (c == '\0') {
			break;
		} else if (c != '%') {
			dest[i++] = c;
			continue;
		}

		c = *fmt++;

		if (c == '%') {
			dest[i++] = c;
			continue;
		}

		struct FormatSpec spec = fmt_NewSpec();

		while (c != '\0') {
			fmt_UseCharacter(&spec, c);
			if (fmt_IsFinished(&spec))
				break;
			c = *fmt++;
		}

		if (fmt_IsEmpty(&spec)) {
			error("STRFMT: Illegal '%%' at end of format string\n");
			dest[i++] = '%';
			break;
		} else if (!fmt_IsValid(&spec)) {
			error("STRFMT: Invalid format spec for argument %zu\n", a + 1);
			dest[i++] = '%';
			a++;
			continue;
		} else if (a >= nbArgs) {
			// Will warn after formatting is done.
			dest[i++] = '%';
			a++;
			continue;
		}

		struct StrFmtArg *arg = &args[a++];
		static char buf[MAXSTRLEN + 1];

		if (arg->isNumeric)
			fmt_PrintNumber(buf, sizeof(buf), &spec, arg->number);
		else
			fmt_PrintString(buf, sizeof(buf), &spec, arg->string);

		i += snprintf(&dest[i], destLen - i, "%s", buf);
	}

	if (a < nbArgs)
		error("STRFMT: %zu unformatted argument(s)\n", nbArgs - a);
	else if (a > nbArgs)
		error("STRFMT: Not enough arguments for format spec, got: %zu, need: %zu\n", nbArgs, a);

	if (i > destLen - 1) {
		warning(WARNING_LONG_STR, "STRFMT: String too long, got truncated\n");
		i = destLen - 1;
	}
	dest[i] = '\0';
}

static void compoundAssignment(const char *symName, enum RPNCommand op, int32_t constValue) {
	struct Expression oldExpr, constExpr, newExpr;
	int32_t newValue;

	rpn_Symbol(&oldExpr, symName);
	rpn_Number(&constExpr, constValue);
	rpn_BinaryOp(op, &newExpr, &oldExpr, &constExpr);
	newValue = rpn_GetConstVal(&newExpr);
	sym_AddVar(symName, newValue);
}

static void initDsArgList(struct DsArgList *args)
{
	args->nbArgs = 0;
	args->capacity = INITIAL_DS_ARG_SIZE;
	args->args = malloc(args->capacity * sizeof(*args->args));
	if (!args->args)
		fatalerror("Failed to allocate memory for ds arg list: %s\n",
			   strerror(errno));
}

static size_t nextDsArgListIndex(struct DsArgList *args)
{
	if (args->nbArgs == args->capacity) {
		args->capacity = (args->capacity + 1) * 2;
		args->args = realloc(args->args, args->capacity * sizeof(*args->args));
		if (!args->args)
			fatalerror("realloc error while resizing ds arg list: %s\n",
				   strerror(errno));
	}
	return args->nbArgs++;
}

static void freeDsArgList(struct DsArgList *args)
{
	free(args->args);
}

static void failAssert(enum AssertionType type)
{
	switch (type) {
		case ASSERT_FATAL:
			fatalerror("Assertion failed\n");
		case ASSERT_ERROR:
			error("Assertion failed\n");
			break;
		case ASSERT_WARN:
			warning(WARNING_ASSERT, "Assertion failed\n");
			break;
	}
}

static void failAssertMsg(enum AssertionType type, char const *msg)
{
	switch (type) {
		case ASSERT_FATAL:
			fatalerror("Assertion failed: %s\n", msg);
		case ASSERT_ERROR:
			error("Assertion failed: %s\n", msg);
			break;
		case ASSERT_WARN:
			warning(WARNING_ASSERT, "Assertion failed: %s\n", msg);
			break;
	}
}

void yyerror(char const *str)
{
	error("%s\n", str);
}

// The CPU encodes instructions in a logical way, so most instructions actually follow patterns.
// These enums thus help with bit twiddling to compute opcodes
enum {
	REG_B = 0,
	REG_C,
	REG_D,
	REG_E,
	REG_H,
	REG_L,
	REG_HL_IND,
	REG_A
};

enum {
	REG_BC_IND = 0,
	REG_DE_IND,
	REG_HL_INDINC,
	REG_HL_INDDEC,
};

enum {
	REG_BC = 0,
	REG_DE = 1,
	REG_HL = 2,
	// LD/INC/ADD/DEC allow SP, PUSH/POP allow AF
	REG_SP = 3,
	REG_AF = 3
};

enum {
	CC_NZ = 0,
	CC_Z,
	CC_NC,
	CC_C
};


#line 538 "src/asm/parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_NUMBER = 3,                   /* "number"  */
  YYSYMBOL_T_STRING = 4,                   /* "string"  */
  YYSYMBOL_T_PERIOD = 5,                   /* "."  */
  YYSYMBOL_T_COMMA = 6,                    /* ","  */
  YYSYMBOL_T_COLON = 7,                    /* ":"  */
  YYSYMBOL_T_LBRACK = 8,                   /* "["  */
  YYSYMBOL_T_RBRACK = 9,                   /* "]"  */
  YYSYMBOL_T_LPAREN = 10,                  /* "("  */
  YYSYMBOL_T_RPAREN = 11,                  /* ")"  */
  YYSYMBOL_T_NEWLINE = 12,                 /* "newline"  */
  YYSYMBOL_T_OP_LOGICNOT = 13,             /* "!"  */
  YYSYMBOL_T_OP_LOGICAND = 14,             /* "&&"  */
  YYSYMBOL_T_OP_LOGICOR = 15,              /* "||"  */
  YYSYMBOL_T_OP_LOGICGT = 16,              /* ">"  */
  YYSYMBOL_T_OP_LOGICLT = 17,              /* "<"  */
  YYSYMBOL_T_OP_LOGICGE = 18,              /* ">="  */
  YYSYMBOL_T_OP_LOGICLE = 19,              /* "<="  */
  YYSYMBOL_T_OP_LOGICNE = 20,              /* "!="  */
  YYSYMBOL_T_OP_LOGICEQU = 21,             /* "=="  */
  YYSYMBOL_T_OP_ADD = 22,                  /* "+"  */
  YYSYMBOL_T_OP_SUB = 23,                  /* "-"  */
  YYSYMBOL_T_OP_OR = 24,                   /* "|"  */
  YYSYMBOL_T_OP_XOR = 25,                  /* "^"  */
  YYSYMBOL_T_OP_AND = 26,                  /* "&"  */
  YYSYMBOL_T_OP_SHL = 27,                  /* "<<"  */
  YYSYMBOL_T_OP_SHR = 28,                  /* ">>"  */
  YYSYMBOL_T_OP_MUL = 29,                  /* "*"  */
  YYSYMBOL_T_OP_DIV = 30,                  /* "/"  */
  YYSYMBOL_T_OP_MOD = 31,                  /* "%"  */
  YYSYMBOL_T_OP_NOT = 32,                  /* "~"  */
  YYSYMBOL_NEG = 33,                       /* NEG  */
  YYSYMBOL_T_OP_EXP = 34,                  /* "**"  */
  YYSYMBOL_T_OP_DEF = 35,                  /* "DEF"  */
  YYSYMBOL_T_OP_BANK = 36,                 /* "BANK"  */
  YYSYMBOL_T_OP_ALIGN = 37,                /* "ALIGN"  */
  YYSYMBOL_T_OP_SIZEOF = 38,               /* "SIZEOF"  */
  YYSYMBOL_T_OP_STARTOF = 39,              /* "STARTOF"  */
  YYSYMBOL_T_OP_SIN = 40,                  /* "SIN"  */
  YYSYMBOL_T_OP_COS = 41,                  /* "COS"  */
  YYSYMBOL_T_OP_TAN = 42,                  /* "TAN"  */
  YYSYMBOL_T_OP_ASIN = 43,                 /* "ASIN"  */
  YYSYMBOL_T_OP_ACOS = 44,                 /* "ACOS"  */
  YYSYMBOL_T_OP_ATAN = 45,                 /* "ATAN"  */
  YYSYMBOL_T_OP_ATAN2 = 46,                /* "ATAN2"  */
  YYSYMBOL_T_OP_FDIV = 47,                 /* "FDIV"  */
  YYSYMBOL_T_OP_FMUL = 48,                 /* "FMUL"  */
  YYSYMBOL_T_OP_POW = 49,                  /* "POW"  */
  YYSYMBOL_T_OP_LOG = 50,                  /* "LOG"  */
  YYSYMBOL_T_OP_ROUND = 51,                /* "ROUND"  */
  YYSYMBOL_T_OP_CEIL = 52,                 /* "CEIL"  */
  YYSYMBOL_T_OP_FLOOR = 53,                /* "FLOOR"  */
  YYSYMBOL_T_OP_HIGH = 54,                 /* "HIGH"  */
  YYSYMBOL_T_OP_LOW = 55,                  /* "LOW"  */
  YYSYMBOL_T_OP_ISCONST = 56,              /* "ISCONST"  */
  YYSYMBOL_T_OP_STRCMP = 57,               /* "STRCMP"  */
  YYSYMBOL_T_OP_STRIN = 58,                /* "STRIN"  */
  YYSYMBOL_T_OP_STRRIN = 59,               /* "STRRIN"  */
  YYSYMBOL_T_OP_STRSUB = 60,               /* "STRSUB"  */
  YYSYMBOL_T_OP_STRLEN = 61,               /* "STRLEN"  */
  YYSYMBOL_T_OP_STRCAT = 62,               /* "STRCAT"  */
  YYSYMBOL_T_OP_STRUPR = 63,               /* "STRUPR"  */
  YYSYMBOL_T_OP_STRLWR = 64,               /* "STRLWR"  */
  YYSYMBOL_T_OP_STRRPL = 65,               /* "STRRPL"  */
  YYSYMBOL_T_OP_STRFMT = 66,               /* "STRFMT"  */
  YYSYMBOL_T_OP_CHARLEN = 67,              /* "CHARLEN"  */
  YYSYMBOL_T_OP_CHARSUB = 68,              /* "CHARSUB"  */
  YYSYMBOL_T_LABEL = 69,                   /* "label"  */
  YYSYMBOL_T_ID = 70,                      /* "identifier"  */
  YYSYMBOL_T_LOCAL_ID = 71,                /* "local identifier"  */
  YYSYMBOL_T_ANON = 72,                    /* "anonymous label"  */
  YYSYMBOL_T_POP_EQU = 73,                 /* "EQU"  */
  YYSYMBOL_T_POP_SET = 74,                 /* "SET"  */
  YYSYMBOL_T_POP_EQUAL = 75,               /* "="  */
  YYSYMBOL_T_POP_EQUS = 76,                /* "EQUS"  */
  YYSYMBOL_T_POP_ADDEQ = 77,               /* "+="  */
  YYSYMBOL_T_POP_SUBEQ = 78,               /* "-="  */
  YYSYMBOL_T_POP_MULEQ = 79,               /* "*="  */
  YYSYMBOL_T_POP_DIVEQ = 80,               /* "/="  */
  YYSYMBOL_T_POP_MODEQ = 81,               /* "%="  */
  YYSYMBOL_T_POP_OREQ = 82,                /* "|="  */
  YYSYMBOL_T_POP_XOREQ = 83,               /* "^="  */
  YYSYMBOL_T_POP_ANDEQ = 84,               /* "&="  */
  YYSYMBOL_T_POP_SHLEQ = 85,               /* "<<="  */
  YYSYMBOL_T_POP_SHREQ = 86,               /* ">>="  */
  YYSYMBOL_T_POP_INCLUDE = 87,             /* "INCLUDE"  */
  YYSYMBOL_T_POP_PRINT = 88,               /* "PRINT"  */
  YYSYMBOL_T_POP_PRINTLN = 89,             /* "PRINTLN"  */
  YYSYMBOL_T_POP_PRINTF = 90,              /* "PRINTF"  */
  YYSYMBOL_T_POP_PRINTT = 91,              /* "PRINTT"  */
  YYSYMBOL_T_POP_PRINTV = 92,              /* "PRINTV"  */
  YYSYMBOL_T_POP_PRINTI = 93,              /* "PRINTI"  */
  YYSYMBOL_T_POP_IF = 94,                  /* "IF"  */
  YYSYMBOL_T_POP_ELIF = 95,                /* "ELIF"  */
  YYSYMBOL_T_POP_ELSE = 96,                /* "ELSE"  */
  YYSYMBOL_T_POP_ENDC = 97,                /* "ENDC"  */
  YYSYMBOL_T_POP_EXPORT = 98,              /* "EXPORT"  */
  YYSYMBOL_T_POP_DB = 99,                  /* "DB"  */
  YYSYMBOL_T_POP_DS = 100,                 /* "DS"  */
  YYSYMBOL_T_POP_DW = 101,                 /* "DW"  */
  YYSYMBOL_T_POP_DL = 102,                 /* "DL"  */
  YYSYMBOL_T_POP_SECTION = 103,            /* "SECTION"  */
  YYSYMBOL_T_POP_FRAGMENT = 104,           /* "FRAGMENT"  */
  YYSYMBOL_T_POP_RB = 105,                 /* "RB"  */
  YYSYMBOL_T_POP_RW = 106,                 /* "RW"  */
  YYSYMBOL_T_POP_MACRO = 107,              /* "MACRO"  */
  YYSYMBOL_T_POP_ENDM = 108,               /* "ENDM"  */
  YYSYMBOL_T_POP_RSRESET = 109,            /* "RSRESET"  */
  YYSYMBOL_T_POP_RSSET = 110,              /* "RSSET"  */
  YYSYMBOL_T_POP_UNION = 111,              /* "UNION"  */
  YYSYMBOL_T_POP_NEXTU = 112,              /* "NEXTU"  */
  YYSYMBOL_T_POP_ENDU = 113,               /* "ENDU"  */
  YYSYMBOL_T_POP_INCBIN = 114,             /* "INCBIN"  */
  YYSYMBOL_T_POP_REPT = 115,               /* "REPT"  */
  YYSYMBOL_T_POP_FOR = 116,                /* "FOR"  */
  YYSYMBOL_T_POP_CHARMAP = 117,            /* "CHARMAP"  */
  YYSYMBOL_T_POP_NEWCHARMAP = 118,         /* "NEWCHARMAP"  */
  YYSYMBOL_T_POP_SETCHARMAP = 119,         /* "SETCHARMAP"  */
  YYSYMBOL_T_POP_PUSHC = 120,              /* "PUSHC"  */
  YYSYMBOL_T_POP_POPC = 121,               /* "POPC"  */
  YYSYMBOL_T_POP_SHIFT = 122,              /* "SHIFT"  */
  YYSYMBOL_T_POP_ENDR = 123,               /* "ENDR"  */
  YYSYMBOL_T_POP_BREAK = 124,              /* "BREAK"  */
  YYSYMBOL_T_POP_LOAD = 125,               /* "LOAD"  */
  YYSYMBOL_T_POP_ENDL = 126,               /* "ENDL"  */
  YYSYMBOL_T_POP_FAIL = 127,               /* "FAIL"  */
  YYSYMBOL_T_POP_WARN = 128,               /* "WARN"  */
  YYSYMBOL_T_POP_FATAL = 129,              /* "FATAL"  */
  YYSYMBOL_T_POP_ASSERT = 130,             /* "ASSERT"  */
  YYSYMBOL_T_POP_STATIC_ASSERT = 131,      /* "STATIC_ASSERT"  */
  YYSYMBOL_T_POP_PURGE = 132,              /* "PURGE"  */
  YYSYMBOL_T_POP_REDEF = 133,              /* "REDEF"  */
  YYSYMBOL_T_POP_POPS = 134,               /* "POPS"  */
  YYSYMBOL_T_POP_PUSHS = 135,              /* "PUSHS"  */
  YYSYMBOL_T_POP_POPO = 136,               /* "POPO"  */
  YYSYMBOL_T_POP_PUSHO = 137,              /* "PUSHO"  */
  YYSYMBOL_T_POP_OPT = 138,                /* "OPT"  */
  YYSYMBOL_T_SECT_ROM0 = 139,              /* "ROM0"  */
  YYSYMBOL_T_SECT_ROMX = 140,              /* "ROMX"  */
  YYSYMBOL_T_SECT_WRAM0 = 141,             /* "WRAM0"  */
  YYSYMBOL_T_SECT_WRAMX = 142,             /* "WRAMX"  */
  YYSYMBOL_T_SECT_HRAM = 143,              /* "HRAM"  */
  YYSYMBOL_T_SECT_VRAM = 144,              /* "VRAM"  */
  YYSYMBOL_T_SECT_SRAM = 145,              /* "SRAM"  */
  YYSYMBOL_T_SECT_OAM = 146,               /* "OAM"  */
  YYSYMBOL_T_Z80_ADC = 147,                /* "adc"  */
  YYSYMBOL_T_Z80_ADD = 148,                /* "add"  */
  YYSYMBOL_T_Z80_AND = 149,                /* "and"  */
  YYSYMBOL_T_Z80_BIT = 150,                /* "bit"  */
  YYSYMBOL_T_Z80_CALL = 151,               /* "call"  */
  YYSYMBOL_T_Z80_CCF = 152,                /* "ccf"  */
  YYSYMBOL_T_Z80_CP = 153,                 /* "cp"  */
  YYSYMBOL_T_Z80_CPL = 154,                /* "cpl"  */
  YYSYMBOL_T_Z80_DAA = 155,                /* "daa"  */
  YYSYMBOL_T_Z80_DEC = 156,                /* "dec"  */
  YYSYMBOL_T_Z80_DI = 157,                 /* "di"  */
  YYSYMBOL_T_Z80_EI = 158,                 /* "ei"  */
  YYSYMBOL_T_Z80_HALT = 159,               /* "halt"  */
  YYSYMBOL_T_Z80_INC = 160,                /* "inc"  */
  YYSYMBOL_T_Z80_JP = 161,                 /* "jp"  */
  YYSYMBOL_T_Z80_JR = 162,                 /* "jr"  */
  YYSYMBOL_T_Z80_LD = 163,                 /* "ld"  */
  YYSYMBOL_T_Z80_LDI = 164,                /* "ldi"  */
  YYSYMBOL_T_Z80_LDD = 165,                /* "ldd"  */
  YYSYMBOL_T_Z80_LDH = 166,                /* "ldh"  */
  YYSYMBOL_T_Z80_NOP = 167,                /* "nop"  */
  YYSYMBOL_T_Z80_OR = 168,                 /* "or"  */
  YYSYMBOL_T_Z80_POP = 169,                /* "pop"  */
  YYSYMBOL_T_Z80_PUSH = 170,               /* "push"  */
  YYSYMBOL_T_Z80_RES = 171,                /* "res"  */
  YYSYMBOL_T_Z80_RET = 172,                /* "ret"  */
  YYSYMBOL_T_Z80_RETI = 173,               /* "reti"  */
  YYSYMBOL_T_Z80_RST = 174,                /* "rst"  */
  YYSYMBOL_T_Z80_RL = 175,                 /* "rl"  */
  YYSYMBOL_T_Z80_RLA = 176,                /* "rla"  */
  YYSYMBOL_T_Z80_RLC = 177,                /* "rlc"  */
  YYSYMBOL_T_Z80_RLCA = 178,               /* "rlca"  */
  YYSYMBOL_T_Z80_RR = 179,                 /* "rr"  */
  YYSYMBOL_T_Z80_RRA = 180,                /* "rra"  */
  YYSYMBOL_T_Z80_RRC = 181,                /* "rrc"  */
  YYSYMBOL_T_Z80_RRCA = 182,               /* "rrca"  */
  YYSYMBOL_T_Z80_SBC = 183,                /* "sbc"  */
  YYSYMBOL_T_Z80_SCF = 184,                /* "scf"  */
  YYSYMBOL_T_Z80_STOP = 185,               /* "stop"  */
  YYSYMBOL_T_Z80_SLA = 186,                /* "sla"  */
  YYSYMBOL_T_Z80_SRA = 187,                /* "sra"  */
  YYSYMBOL_T_Z80_SRL = 188,                /* "srl"  */
  YYSYMBOL_T_Z80_SUB = 189,                /* "sub"  */
  YYSYMBOL_T_Z80_SWAP = 190,               /* "swap"  */
  YYSYMBOL_T_Z80_XOR = 191,                /* "xor"  */
  YYSYMBOL_T_TOKEN_A = 192,                /* "a"  */
  YYSYMBOL_T_TOKEN_B = 193,                /* "b"  */
  YYSYMBOL_T_TOKEN_C = 194,                /* "c"  */
  YYSYMBOL_T_TOKEN_D = 195,                /* "d"  */
  YYSYMBOL_T_TOKEN_E = 196,                /* "e"  */
  YYSYMBOL_T_TOKEN_H = 197,                /* "h"  */
  YYSYMBOL_T_TOKEN_L = 198,                /* "l"  */
  YYSYMBOL_T_MODE_AF = 199,                /* "af"  */
  YYSYMBOL_T_MODE_BC = 200,                /* "bc"  */
  YYSYMBOL_T_MODE_DE = 201,                /* "de"  */
  YYSYMBOL_T_MODE_SP = 202,                /* "sp"  */
  YYSYMBOL_T_MODE_HL = 203,                /* "hl"  */
  YYSYMBOL_T_MODE_HL_DEC = 204,            /* "hld/hl-"  */
  YYSYMBOL_T_MODE_HL_INC = 205,            /* "hli/hl+"  */
  YYSYMBOL_T_CC_NZ = 206,                  /* "nz"  */
  YYSYMBOL_T_CC_Z = 207,                   /* "z"  */
  YYSYMBOL_T_CC_NC = 208,                  /* "nc"  */
  YYSYMBOL_T_EOB = 209,                    /* "end of buffer"  */
  YYSYMBOL_YYACCEPT = 210,                 /* $accept  */
  YYSYMBOL_asmfile = 211,                  /* asmfile  */
  YYSYMBOL_lines = 212,                    /* lines  */
  YYSYMBOL_endofline = 213,                /* endofline  */
  YYSYMBOL_plain_directive = 214,          /* plain_directive  */
  YYSYMBOL_line = 215,                     /* line  */
  YYSYMBOL_216_1 = 216,                    /* $@1  */
  YYSYMBOL_217_2 = 217,                    /* $@2  */
  YYSYMBOL_line_directive = 218,           /* line_directive  */
  YYSYMBOL_if = 219,                       /* if  */
  YYSYMBOL_elif = 220,                     /* elif  */
  YYSYMBOL_else = 221,                     /* else  */
  YYSYMBOL_endc = 222,                     /* endc  */
  YYSYMBOL_def_id = 223,                   /* def_id  */
  YYSYMBOL_224_3 = 224,                    /* $@3  */
  YYSYMBOL_redef_id = 225,                 /* redef_id  */
  YYSYMBOL_226_4 = 226,                    /* $@4  */
  YYSYMBOL_scoped_id = 227,                /* scoped_id  */
  YYSYMBOL_scoped_anon_id = 228,           /* scoped_anon_id  */
  YYSYMBOL_label = 229,                    /* label  */
  YYSYMBOL_macro = 230,                    /* macro  */
  YYSYMBOL_231_5 = 231,                    /* $@5  */
  YYSYMBOL_macroargs = 232,                /* macroargs  */
  YYSYMBOL_assignment_directive = 233,     /* assignment_directive  */
  YYSYMBOL_directive = 234,                /* directive  */
  YYSYMBOL_trailing_comma = 235,           /* trailing_comma  */
  YYSYMBOL_compoundeq = 236,               /* compoundeq  */
  YYSYMBOL_equ = 237,                      /* equ  */
  YYSYMBOL_set = 238,                      /* set  */
  YYSYMBOL_equs = 239,                     /* equs  */
  YYSYMBOL_rb = 240,                       /* rb  */
  YYSYMBOL_rw = 241,                       /* rw  */
  YYSYMBOL_rl = 242,                       /* rl  */
  YYSYMBOL_align = 243,                    /* align  */
  YYSYMBOL_opt = 244,                      /* opt  */
  YYSYMBOL_245_6 = 245,                    /* $@6  */
  YYSYMBOL_opt_list = 246,                 /* opt_list  */
  YYSYMBOL_opt_list_entry = 247,           /* opt_list_entry  */
  YYSYMBOL_popo = 248,                     /* popo  */
  YYSYMBOL_pusho = 249,                    /* pusho  */
  YYSYMBOL_pops = 250,                     /* pops  */
  YYSYMBOL_pushs = 251,                    /* pushs  */
  YYSYMBOL_fail = 252,                     /* fail  */
  YYSYMBOL_warn = 253,                     /* warn  */
  YYSYMBOL_assert_type = 254,              /* assert_type  */
  YYSYMBOL_assert = 255,                   /* assert  */
  YYSYMBOL_shift = 256,                    /* shift  */
  YYSYMBOL_load = 257,                     /* load  */
  YYSYMBOL_rept = 258,                     /* rept  */
  YYSYMBOL_259_7 = 259,                    /* @7  */
  YYSYMBOL_for = 260,                      /* for  */
  YYSYMBOL_261_8 = 261,                    /* $@8  */
  YYSYMBOL_262_9 = 262,                    /* $@9  */
  YYSYMBOL_263_10 = 263,                   /* @10  */
  YYSYMBOL_for_args = 264,                 /* for_args  */
  YYSYMBOL_break = 265,                    /* break  */
  YYSYMBOL_macrodef = 266,                 /* macrodef  */
  YYSYMBOL_267_11 = 267,                   /* $@11  */
  YYSYMBOL_268_12 = 268,                   /* $@12  */
  YYSYMBOL_269_13 = 269,                   /* @13  */
  YYSYMBOL_270_14 = 270,                   /* @14  */
  YYSYMBOL_rsset = 271,                    /* rsset  */
  YYSYMBOL_rsreset = 272,                  /* rsreset  */
  YYSYMBOL_rs_uconst = 273,                /* rs_uconst  */
  YYSYMBOL_union = 274,                    /* union  */
  YYSYMBOL_nextu = 275,                    /* nextu  */
  YYSYMBOL_endu = 276,                     /* endu  */
  YYSYMBOL_ds = 277,                       /* ds  */
  YYSYMBOL_ds_args = 278,                  /* ds_args  */
  YYSYMBOL_db = 279,                       /* db  */
  YYSYMBOL_dw = 280,                       /* dw  */
  YYSYMBOL_dl = 281,                       /* dl  */
  YYSYMBOL_def_equ = 282,                  /* def_equ  */
  YYSYMBOL_redef_equ = 283,                /* redef_equ  */
  YYSYMBOL_def_set = 284,                  /* def_set  */
  YYSYMBOL_def_rb = 285,                   /* def_rb  */
  YYSYMBOL_def_rw = 286,                   /* def_rw  */
  YYSYMBOL_def_rl = 287,                   /* def_rl  */
  YYSYMBOL_def_equs = 288,                 /* def_equs  */
  YYSYMBOL_redef_equs = 289,               /* redef_equs  */
  YYSYMBOL_purge = 290,                    /* purge  */
  YYSYMBOL_291_15 = 291,                   /* $@15  */
  YYSYMBOL_purge_list = 292,               /* purge_list  */
  YYSYMBOL_purge_list_entry = 293,         /* purge_list_entry  */
  YYSYMBOL_export = 294,                   /* export  */
  YYSYMBOL_export_list = 295,              /* export_list  */
  YYSYMBOL_export_list_entry = 296,        /* export_list_entry  */
  YYSYMBOL_include = 297,                  /* include  */
  YYSYMBOL_incbin = 298,                   /* incbin  */
  YYSYMBOL_charmap = 299,                  /* charmap  */
  YYSYMBOL_newcharmap = 300,               /* newcharmap  */
  YYSYMBOL_setcharmap = 301,               /* setcharmap  */
  YYSYMBOL_pushc = 302,                    /* pushc  */
  YYSYMBOL_popc = 303,                     /* popc  */
  YYSYMBOL_print = 304,                    /* print  */
  YYSYMBOL_println = 305,                  /* println  */
  YYSYMBOL_print_exprs = 306,              /* print_exprs  */
  YYSYMBOL_print_expr = 307,               /* print_expr  */
  YYSYMBOL_printt = 308,                   /* printt  */
  YYSYMBOL_printv = 309,                   /* printv  */
  YYSYMBOL_printi = 310,                   /* printi  */
  YYSYMBOL_printf = 311,                   /* printf  */
  YYSYMBOL_const_3bit = 312,               /* const_3bit  */
  YYSYMBOL_constlist_8bit = 313,           /* constlist_8bit  */
  YYSYMBOL_constlist_8bit_entry = 314,     /* constlist_8bit_entry  */
  YYSYMBOL_constlist_16bit = 315,          /* constlist_16bit  */
  YYSYMBOL_constlist_16bit_entry = 316,    /* constlist_16bit_entry  */
  YYSYMBOL_constlist_32bit = 317,          /* constlist_32bit  */
  YYSYMBOL_constlist_32bit_entry = 318,    /* constlist_32bit_entry  */
  YYSYMBOL_reloc_8bit = 319,               /* reloc_8bit  */
  YYSYMBOL_reloc_8bit_no_str = 320,        /* reloc_8bit_no_str  */
  YYSYMBOL_reloc_8bit_offset = 321,        /* reloc_8bit_offset  */
  YYSYMBOL_reloc_16bit = 322,              /* reloc_16bit  */
  YYSYMBOL_reloc_16bit_no_str = 323,       /* reloc_16bit_no_str  */
  YYSYMBOL_relocexpr = 324,                /* relocexpr  */
  YYSYMBOL_relocexpr_no_str = 325,         /* relocexpr_no_str  */
  YYSYMBOL_326_16 = 326,                   /* $@16  */
  YYSYMBOL_uconst = 327,                   /* uconst  */
  YYSYMBOL_const = 328,                    /* const  */
  YYSYMBOL_const_no_str = 329,             /* const_no_str  */
  YYSYMBOL_const_8bit = 330,               /* const_8bit  */
  YYSYMBOL_string = 331,                   /* string  */
  YYSYMBOL_strcat_args = 332,              /* strcat_args  */
  YYSYMBOL_strfmt_args = 333,              /* strfmt_args  */
  YYSYMBOL_strfmt_va_args = 334,           /* strfmt_va_args  */
  YYSYMBOL_section = 335,                  /* section  */
  YYSYMBOL_sectmod = 336,                  /* sectmod  */
  YYSYMBOL_sectiontype = 337,              /* sectiontype  */
  YYSYMBOL_sectorg = 338,                  /* sectorg  */
  YYSYMBOL_sectattrs = 339,                /* sectattrs  */
  YYSYMBOL_cpu_command = 340,              /* cpu_command  */
  YYSYMBOL_z80_adc = 341,                  /* z80_adc  */
  YYSYMBOL_z80_add = 342,                  /* z80_add  */
  YYSYMBOL_z80_and = 343,                  /* z80_and  */
  YYSYMBOL_z80_bit = 344,                  /* z80_bit  */
  YYSYMBOL_z80_call = 345,                 /* z80_call  */
  YYSYMBOL_z80_ccf = 346,                  /* z80_ccf  */
  YYSYMBOL_z80_cp = 347,                   /* z80_cp  */
  YYSYMBOL_z80_cpl = 348,                  /* z80_cpl  */
  YYSYMBOL_z80_daa = 349,                  /* z80_daa  */
  YYSYMBOL_z80_dec = 350,                  /* z80_dec  */
  YYSYMBOL_z80_di = 351,                   /* z80_di  */
  YYSYMBOL_z80_ei = 352,                   /* z80_ei  */
  YYSYMBOL_z80_halt = 353,                 /* z80_halt  */
  YYSYMBOL_z80_inc = 354,                  /* z80_inc  */
  YYSYMBOL_z80_jp = 355,                   /* z80_jp  */
  YYSYMBOL_z80_jr = 356,                   /* z80_jr  */
  YYSYMBOL_z80_ldi = 357,                  /* z80_ldi  */
  YYSYMBOL_z80_ldd = 358,                  /* z80_ldd  */
  YYSYMBOL_z80_ldio = 359,                 /* z80_ldio  */
  YYSYMBOL_c_ind = 360,                    /* c_ind  */
  YYSYMBOL_z80_ld = 361,                   /* z80_ld  */
  YYSYMBOL_z80_ld_hl = 362,                /* z80_ld_hl  */
  YYSYMBOL_z80_ld_sp = 363,                /* z80_ld_sp  */
  YYSYMBOL_z80_ld_mem = 364,               /* z80_ld_mem  */
  YYSYMBOL_z80_ld_cind = 365,              /* z80_ld_cind  */
  YYSYMBOL_z80_ld_rr = 366,                /* z80_ld_rr  */
  YYSYMBOL_z80_ld_r = 367,                 /* z80_ld_r  */
  YYSYMBOL_z80_ld_a = 368,                 /* z80_ld_a  */
  YYSYMBOL_z80_ld_ss = 369,                /* z80_ld_ss  */
  YYSYMBOL_z80_nop = 370,                  /* z80_nop  */
  YYSYMBOL_z80_or = 371,                   /* z80_or  */
  YYSYMBOL_z80_pop = 372,                  /* z80_pop  */
  YYSYMBOL_z80_push = 373,                 /* z80_push  */
  YYSYMBOL_z80_res = 374,                  /* z80_res  */
  YYSYMBOL_z80_ret = 375,                  /* z80_ret  */
  YYSYMBOL_z80_reti = 376,                 /* z80_reti  */
  YYSYMBOL_z80_rl = 377,                   /* z80_rl  */
  YYSYMBOL_z80_rla = 378,                  /* z80_rla  */
  YYSYMBOL_z80_rlc = 379,                  /* z80_rlc  */
  YYSYMBOL_z80_rlca = 380,                 /* z80_rlca  */
  YYSYMBOL_z80_rr = 381,                   /* z80_rr  */
  YYSYMBOL_z80_rra = 382,                  /* z80_rra  */
  YYSYMBOL_z80_rrc = 383,                  /* z80_rrc  */
  YYSYMBOL_z80_rrca = 384,                 /* z80_rrca  */
  YYSYMBOL_z80_rst = 385,                  /* z80_rst  */
  YYSYMBOL_z80_sbc = 386,                  /* z80_sbc  */
  YYSYMBOL_z80_scf = 387,                  /* z80_scf  */
  YYSYMBOL_z80_set = 388,                  /* z80_set  */
  YYSYMBOL_z80_sla = 389,                  /* z80_sla  */
  YYSYMBOL_z80_sra = 390,                  /* z80_sra  */
  YYSYMBOL_z80_srl = 391,                  /* z80_srl  */
  YYSYMBOL_z80_stop = 392,                 /* z80_stop  */
  YYSYMBOL_z80_sub = 393,                  /* z80_sub  */
  YYSYMBOL_z80_swap = 394,                 /* z80_swap  */
  YYSYMBOL_z80_xor = 395,                  /* z80_xor  */
  YYSYMBOL_op_mem_ind = 396,               /* op_mem_ind  */
  YYSYMBOL_op_a_r = 397,                   /* op_a_r  */
  YYSYMBOL_op_a_n = 398,                   /* op_a_n  */
  YYSYMBOL_T_MODE_A = 399,                 /* T_MODE_A  */
  YYSYMBOL_T_MODE_B = 400,                 /* T_MODE_B  */
  YYSYMBOL_T_MODE_C = 401,                 /* T_MODE_C  */
  YYSYMBOL_T_MODE_D = 402,                 /* T_MODE_D  */
  YYSYMBOL_T_MODE_E = 403,                 /* T_MODE_E  */
  YYSYMBOL_T_MODE_H = 404,                 /* T_MODE_H  */
  YYSYMBOL_T_MODE_L = 405,                 /* T_MODE_L  */
  YYSYMBOL_ccode_expr = 406,               /* ccode_expr  */
  YYSYMBOL_ccode = 407,                    /* ccode  */
  YYSYMBOL_reg_r = 408,                    /* reg_r  */
  YYSYMBOL_reg_tt = 409,                   /* reg_tt  */
  YYSYMBOL_reg_ss = 410,                   /* reg_ss  */
  YYSYMBOL_reg_rr = 411,                   /* reg_rr  */
  YYSYMBOL_hl_ind_inc = 412,               /* hl_ind_inc  */
  YYSYMBOL_hl_ind_dec = 413                /* hl_ind_dec  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2318

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  210
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  204
/* YYNRULES -- Number of rules.  */
#define YYNRULES  520
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  917

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   464


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX) YY_CAST (yysymbol_kind_t, YYX)

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   692,   692,   695,   696,   699,   699,   702,   703,   704,
     705,   706,   709,   710,   712,   712,   720,   720,   740,   741,
     742,   743,   744,   745,   747,   748,   751,   761,   778,   794,
     799,   799,   807,   807,   815,   815,   816,   816,   818,   819,
     822,   825,   828,   831,   835,   841,   841,   849,   852,   858,
     859,   860,   861,   862,   863,   866,   867,   868,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   912,
     912,   915,   916,   917,   918,   919,   920,   921,   922,   923,
     924,   927,   930,   931,   932,   938,   941,   947,   953,   959,
     965,   976,   976,   982,   983,   986,   989,   992,   995,   998,
    1001,  1004,  1007,  1008,  1009,  1010,  1013,  1024,  1035,  1039,
    1045,  1046,  1049,  1052,  1055,  1055,  1064,  1066,  1068,  1064,
    1076,  1081,  1086,  1093,  1099,  1101,  1103,  1099,  1110,  1110,
    1119,  1122,  1125,  1126,  1129,  1132,  1135,  1138,  1139,  1145,
    1151,  1159,  1160,  1163,  1164,  1167,  1168,  1171,  1174,  1177,
    1178,  1179,  1180,  1181,  1185,  1191,  1197,  1203,  1209,  1212,
    1215,  1215,  1222,  1223,  1226,  1229,  1232,  1233,  1236,  1239,
    1246,  1251,  1256,  1263,  1268,  1269,  1272,  1275,  1278,  1281,
    1284,  1288,  1294,  1295,  1298,  1299,  1302,  1308,  1314,  1320,
    1326,  1338,  1339,  1342,  1345,  1354,  1355,  1358,  1361,  1370,
    1371,  1374,  1377,  1387,  1393,  1399,  1403,  1409,  1415,  1422,
    1423,  1434,  1435,  1436,  1439,  1442,  1445,  1448,  1451,  1454,
    1457,  1460,  1463,  1466,  1469,  1472,  1475,  1478,  1481,  1484,
    1487,  1490,  1493,  1496,  1497,  1498,  1499,  1500,  1501,  1502,
    1506,  1507,  1508,  1509,  1509,  1518,  1521,  1524,  1527,  1530,
    1533,  1536,  1539,  1542,  1545,  1548,  1551,  1554,  1557,  1560,
    1563,  1568,  1573,  1576,  1579,  1582,  1589,  1592,  1595,  1598,
    1599,  1605,  1611,  1617,  1620,  1623,  1626,  1629,  1632,  1638,
    1639,  1650,  1658,  1661,  1668,  1677,  1682,  1683,  1684,  1687,
    1688,  1689,  1690,  1691,  1692,  1693,  1694,  1697,  1698,  1708,
    1713,  1716,  1720,  1727,  1728,  1729,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,
    1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,
    1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,
    1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1775,
    1779,  1782,  1786,  1787,  1788,  1795,  1799,  1802,  1808,  1812,
    1818,  1821,  1825,  1828,  1831,  1834,  1835,  1838,  1841,  1844,
    1851,  1852,  1855,  1859,  1863,  1868,  1872,  1878,  1881,  1886,
    1889,  1894,  1900,  1906,  1909,  1914,  1915,  1921,  1922,  1923,
    1924,  1925,  1926,  1927,  1928,  1931,  1935,  1941,  1942,  1948,
    1952,  1965,  1970,  1975,  1979,  1987,  1993,  1999,  2017,  2021,
    2031,  2034,  2038,  2041,  2044,  2047,  2053,  2054,  2057,  2060,
    2066,  2069,  2075,  2078,  2084,  2087,  2093,  2096,  2106,  2110,
    2113,  2116,  2122,  2128,  2134,  2140,  2144,  2150,  2154,  2157,
    2163,  2167,  2170,  2173,  2174,  2177,  2178,  2181,  2182,  2185,
    2186,  2189,  2190,  2193,  2194,  2197,  2198,  2201,  2202,  2205,
    2206,  2209,  2210,  2215,  2216,  2217,  2218,  2221,  2222,  2223,
    2224,  2225,  2226,  2227,  2228,  2231,  2232,  2233,  2234,  2237,
    2238,  2239,  2240,  2243,  2244,  2245,  2246,  2249,  2250,  2253,
    2254
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  static const char *const yy_sname[] =
  {
  "end of file", "error", "invalid token", "number", "string", ".", ",",
  ":", "[", "]", "(", ")", "newline", "!", "&&", "||", ">", "<", ">=",
  "<=", "!=", "==", "+", "-", "|", "^", "&", "<<", ">>", "*", "/", "%",
  "~", "NEG", "**", "DEF", "BANK", "ALIGN", "SIZEOF", "STARTOF", "SIN",
  "COS", "TAN", "ASIN", "ACOS", "ATAN", "ATAN2", "FDIV", "FMUL", "POW",
  "LOG", "ROUND", "CEIL", "FLOOR", "HIGH", "LOW", "ISCONST", "STRCMP",
  "STRIN", "STRRIN", "STRSUB", "STRLEN", "STRCAT", "STRUPR", "STRLWR",
  "STRRPL", "STRFMT", "CHARLEN", "CHARSUB", "label", "identifier",
  "local identifier", "anonymous label", "EQU", "SET", "=", "EQUS", "+=",
  "-=", "*=", "/=", "%=", "|=", "^=", "&=", "<<=", ">>=", "INCLUDE",
  "PRINT", "PRINTLN", "PRINTF", "PRINTT", "PRINTV", "PRINTI", "IF", "ELIF",
  "ELSE", "ENDC", "EXPORT", "DB", "DS", "DW", "DL", "SECTION", "FRAGMENT",
  "RB", "RW", "MACRO", "ENDM", "RSRESET", "RSSET", "UNION", "NEXTU",
  "ENDU", "INCBIN", "REPT", "FOR", "CHARMAP", "NEWCHARMAP", "SETCHARMAP",
  "PUSHC", "POPC", "SHIFT", "ENDR", "BREAK", "LOAD", "ENDL", "FAIL",
  "WARN", "FATAL", "ASSERT", "STATIC_ASSERT", "PURGE", "REDEF", "POPS",
  "PUSHS", "POPO", "PUSHO", "OPT", "ROM0", "ROMX", "WRAM0", "WRAMX",
  "HRAM", "VRAM", "SRAM", "OAM", "adc", "add", "and", "bit", "call", "ccf",
  "cp", "cpl", "daa", "dec", "di", "ei", "halt", "inc", "jp", "jr", "ld",
  "ldi", "ldd", "ldh", "nop", "or", "pop", "push", "res", "ret", "reti",
  "rst", "rl", "rla", "rlc", "rlca", "rr", "rra", "rrc", "rrca", "sbc",
  "scf", "stop", "sla", "sra", "srl", "sub", "swap", "xor", "a", "b", "c",
  "d", "e", "h", "l", "af", "bc", "de", "sp", "hl", "hld/hl-", "hli/hl+",
  "nz", "z", "nc", "end of buffer", "$accept", "asmfile", "lines",
  "endofline", "plain_directive", "line", "$@1", "$@2", "line_directive",
  "if", "elif", "else", "endc", "def_id", "$@3", "redef_id", "$@4",
  "scoped_id", "scoped_anon_id", "label", "macro", "$@5", "macroargs",
  "assignment_directive", "directive", "trailing_comma", "compoundeq",
  "equ", "set", "equs", "rb", "rw", "rl", "align", "opt", "$@6",
  "opt_list", "opt_list_entry", "popo", "pusho", "pops", "pushs", "fail",
  "warn", "assert_type", "assert", "shift", "load", "rept", "@7", "for",
  "$@8", "$@9", "@10", "for_args", "break", "macrodef", "$@11", "$@12",
  "@13", "@14", "rsset", "rsreset", "rs_uconst", "union", "nextu", "endu",
  "ds", "ds_args", "db", "dw", "dl", "def_equ", "redef_equ", "def_set",
  "def_rb", "def_rw", "def_rl", "def_equs", "redef_equs", "purge", "$@15",
  "purge_list", "purge_list_entry", "export", "export_list",
  "export_list_entry", "include", "incbin", "charmap", "newcharmap",
  "setcharmap", "pushc", "popc", "print", "println", "print_exprs",
  "print_expr", "printt", "printv", "printi", "printf", "const_3bit",
  "constlist_8bit", "constlist_8bit_entry", "constlist_16bit",
  "constlist_16bit_entry", "constlist_32bit", "constlist_32bit_entry",
  "reloc_8bit", "reloc_8bit_no_str", "reloc_8bit_offset", "reloc_16bit",
  "reloc_16bit_no_str", "relocexpr", "relocexpr_no_str", "$@16", "uconst",
  "const", "const_no_str", "const_8bit", "string", "strcat_args",
  "strfmt_args", "strfmt_va_args", "section", "sectmod", "sectiontype",
  "sectorg", "sectattrs", "cpu_command", "z80_adc", "z80_add", "z80_and",
  "z80_bit", "z80_call", "z80_ccf", "z80_cp", "z80_cpl", "z80_daa",
  "z80_dec", "z80_di", "z80_ei", "z80_halt", "z80_inc", "z80_jp", "z80_jr",
  "z80_ldi", "z80_ldd", "z80_ldio", "c_ind", "z80_ld", "z80_ld_hl",
  "z80_ld_sp", "z80_ld_mem", "z80_ld_cind", "z80_ld_rr", "z80_ld_r",
  "z80_ld_a", "z80_ld_ss", "z80_nop", "z80_or", "z80_pop", "z80_push",
  "z80_res", "z80_ret", "z80_reti", "z80_rl", "z80_rla", "z80_rlc",
  "z80_rlca", "z80_rr", "z80_rra", "z80_rrc", "z80_rrca", "z80_rst",
  "z80_sbc", "z80_scf", "z80_set", "z80_sla", "z80_sra", "z80_srl",
  "z80_stop", "z80_sub", "z80_swap", "z80_xor", "op_mem_ind", "op_a_r",
  "op_a_n", "T_MODE_A", "T_MODE_B", "T_MODE_C", "T_MODE_D", "T_MODE_E",
  "T_MODE_H", "T_MODE_L", "ccode_expr", "ccode", "reg_r", "reg_tt",
  "reg_ss", "reg_rr", "hl_ind_inc", "hl_ind_dec", YY_NULLPTR
  };
  return yy_sname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464
};
#endif

#define YYPACT_NINF (-480)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-315)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -480,    78,  1034,  -480,  -480,  -480,   492,    88,   947,   947,
      48,  -480,   947,  -480,    12,  -480,  -480,  -480,  -480,  -480,
    2127,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,    12,  -480,    43,   947,   947,   947,   128,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
     947,   947,   947,   947,    91,  -480,  -480,   947,   947,   947,
     947,   947,  -480,   103,   107,   130,   156,   162,   164,   166,
     177,   179,   185,   189,   207,   209,   217,   234,   237,   239,
     240,   243,   245,   246,   249,   250,   256,   272,   288,   293,
     294,   295,   296,   310,   311,  -480,  -480,  -480,  -480,  -480,
    1876,  -480,    73,  -480,   137,  -480,   108,   343,  -480,   252,
    -480,  -480,  -480,  -480,   947,  -480,   947,   128,   947,   947,
     947,   128,   947,   947,  -480,    35,   947,   947,   947,   947,
     -38,  -480,   947,  -480,  -480,  -480,   128,   128,   253,   287,
    -480,  -480,   947,    12,   -38,  -480,   128,   128,    79,    79,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  1912,  1400,  1912,
     947,  1223,  -480,  1912,  -480,  -480,    75,  -480,  -480,  -480,
      75,   758,  1223,    99,    20,    54,    60,  -480,  1912,    15,
      15,   947,    57,  -480,   947,    39,  -480,    39,  -480,    39,
    -480,    39,  -480,  1912,  -480,   947,    39,    39,    39,  1912,
      39,  1912,  -480,   289,   597,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,    12,  -480,   346,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  1059,
     325,   325,   325,   325,   350,    71,   128,   128,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   128,   128,   128,   128,   128,
     160,   128,   128,   128,   128,   128,   128,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,  -480,  -480,  -480,  -480,
    -480,   306,   373,  -480,   374,  -480,    12,   377,  -480,  1876,
      32,  -480,    33,   377,  -480,  -480,  -480,  -480,  -480,   378,
    -480,   379,  -480,  -480,    34,    36,   380,   381,  -480,  -480,
      45,    49,   382,  -480,    52,    53,  -480,  -480,   128,  -480,
     384,   385,   386,  -480,  -480,  -480,   128,  -480,  -480,   387,
     390,   392,   947,   947,    35,   329,   398,   200,   394,   395,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  1876,  -480,
    -480,   400,  -480,  -480,  -480,  -480,  -480,  -480,  -480,   401,
     403,  -480,  -480,  -480,  -480,   407,  1223,  -480,  -480,  -480,
    -480,  -480,  1876,   408,  -480,  -480,  -480,   405,   406,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
     411,  -480,   413,  1293,   424,   426,   427,   428,   429,   430,
     431,   432,  -480,  -480,   241,   436,   441,   247,   442,  2079,
     443,   445,   446,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,   449,    57,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
     947,   947,   947,   128,   947,   947,   947,   947,   947,   947,
     947,   128,   947,  -480,  -480,  -480,   168,   447,   448,   450,
     451,   454,   456,   457,   458,   460,   461,   467,   468,   470,
     472,   473,   469,   471,   474,  1355,  1540,  1710,   478,   480,
     484,   485,   481,  -480,  -480,    90,   483,   486,   489,  -480,
     487,   490,   494,   860,   589,   322,   322,   322,   322,   322,
     322,   397,   397,   117,   117,   117,   139,   139,   325,   325,
     325,  -480,   444,    12,   496,  -480,   947,   438,    39,  -480,
     947,  -480,  -480,    35,  -480,   947,  -480,   947,   947,  -480,
     947,  -480,   503,   947,   947,   459,   511,  -480,  -480,  -480,
     826,   513,  -480,   515,  -480,  -480,  -480,   398,  -480,   519,
    1478,  1577,  1912,   947,    84,    39,  -480,   947,    80,   -42,
     947,   947,   520,   522,   523,    81,   524,   525,   530,  2042,
     531,   947,   947,  1648,  1747,     9,   -27,  1983,     9,   532,
     258,   488,   533,   539,     9,     9,   541,    39,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,    12,   540,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,   947,   947,   947,   947,   947,  -480,  -480,
    -480,  -480,  -480,  -480,   128,   128,   128,   947,  -480,   128,
    -480,  -480,  -480,   128,   544,  -480,  -480,   947,  -480,  -480,
     947,  -480,  -480,  -480,  -480,  -480,  -480,   546,  -480,  -480,
    -480,   -18,   549,  -480,  -480,  -480,   -18,   128,   128,    35,
    -480,  -480,  -480,   547,   548,   550,   553,   568,   569,   571,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  1817,  -480,
    -480,   551,   575,  -480,  -480,  -480,  2079,  -480,  -480,  -480,
    -480,  -480,   158,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,   579,   354,   580,   389,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,   576,   578,   583,   584,   585,   588,
     590,   591,   146,  -480,   594,   947,   610,    12,   615,   616,
     947,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
     582,   947,   582,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,   619,   947,   947,  -480,     9,
     621,     9,   623,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,   947,  -480,   128,  -480,   149,  -480,  -480,  -480,   947,
    -480,   947,  -480,  -480,  -480,  -480,  1876,  1876,  -480,  -480,
    -480,  -480,   622,   624,    12,   628,   627,   631,   631,  -480,
    -480,  -480,   947,  -480,   148,  -480,   630,   650,   947,   947,
     651,    63,  -480,   947,  -480,   652,  -480
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       3,     0,     0,     1,    14,    39,     0,    40,     0,     0,
       0,   154,     0,   146,     0,     4,    13,    23,    24,    25,
       7,    11,    49,    50,    54,    51,    52,    53,    19,    20,
      21,    18,    22,     0,    16,    42,     0,     0,     0,     0,
     101,   102,   103,   104,   105,   107,   106,   108,   109,   110,
     162,   162,   162,     0,    41,   242,   299,     0,     0,     0,
       0,     0,   273,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    35,    37,    36,   241,
     296,   239,     0,   240,     0,    28,     0,     0,   295,     0,
       5,     6,    12,    30,     0,    45,     0,     0,     0,   210,
       0,     0,     0,     0,    29,     0,   171,     0,   173,   175,
     316,   161,     0,   164,   165,   166,     0,     0,     0,     0,
     207,   208,   140,     0,   316,   143,     0,     0,   132,   132,
     190,    32,   128,   129,   126,   127,   121,     0,     0,     0,
       0,     0,   390,     0,   393,   394,     0,   397,   398,   399,
       0,     0,     0,     0,     0,     0,     0,   440,     0,     0,
       0,     0,   446,   448,     0,     0,   450,     0,   452,     0,
     454,     0,   456,     0,   460,   465,     0,     0,     0,     0,
       0,     0,    55,     0,     0,     9,    10,    98,    97,    95,
      96,    93,    94,    81,    82,    83,    80,    79,    69,    68,
      70,    71,    72,    66,    63,    64,    65,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    62,    73,    74,    75,
      76,    77,    78,    56,    57,    59,    60,    61,    58,    67,
       8,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   351,   350,   352,
     349,   421,   422,   417,   418,   419,   423,   424,   420,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    15,     0,    44,     0,   111,
     114,   112,   115,   116,   163,   117,   118,   113,    43,     0,
     243,   263,   264,   265,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    26,    27,   155,   144,
     147,     0,   119,    47,     0,   220,     0,    99,   212,     0,
     239,   214,   240,    99,   219,   216,   217,   218,   198,    99,
     196,    99,   221,   223,   239,   240,   167,    99,   225,   227,
     239,   240,    99,   229,   239,   240,   318,   317,     0,   160,
     200,     0,   204,   206,   141,   153,     0,   130,   131,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     477,   479,   481,   483,   485,   487,   489,   475,   233,   380,
     379,   504,   497,   498,   499,   500,   501,   502,   473,     0,
       0,   382,   381,   386,   385,     0,     0,   496,   493,   494,
     495,   388,   237,     0,   491,   392,   391,     0,     0,   509,
     510,   512,   511,   504,   395,   396,   400,   401,   404,   402,
       0,   405,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   442,   441,   508,   505,   506,   507,   443,
     444,     0,     0,   447,   457,   449,   451,   453,   455,   459,
     458,   466,   462,   463,   464,   468,   467,   469,   471,   470,
       0,     0,     0,     0,   162,   162,   162,     0,     0,     0,
       0,     0,     0,    17,   158,   294,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   303,   309,     0,     0,     0,     0,   312,
       0,     0,     0,   245,   244,   247,   248,   249,   250,   251,
     246,   252,   253,   255,   254,   256,   257,   258,   259,   260,
     261,   262,     0,     0,     0,    31,     0,    46,     0,   199,
     100,   209,   211,   100,   195,   100,   172,     0,   100,   174,
     100,   176,     0,     0,     0,     0,     0,   134,   133,   135,
     136,   138,   194,    99,   192,    33,   125,   122,   123,     0,
       0,     0,     0,     0,     0,     0,   492,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   237,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   177,   183,
     179,   188,   185,   186,   187,   181,   178,   184,   180,   189,
     182,     0,     0,   269,   270,   271,   272,   282,   283,   284,
     285,   286,   287,     0,     0,     0,     0,     0,   275,   276,
     277,   266,   267,   268,     0,     0,     0,     0,   292,     0,
     304,   305,   306,     0,   311,   308,   293,     0,   156,   145,
       0,   120,    48,   461,   213,   197,   222,    99,   169,   226,
     230,     0,   201,   298,   203,   205,     0,     0,     0,   100,
     191,   124,   503,     0,     0,     0,     0,     0,     0,     0,
     476,   474,   384,   383,   387,   389,   403,   406,     0,   513,
     514,     0,     0,   519,   517,   472,     0,   415,   438,   439,
     427,   428,     0,   426,   431,   429,   430,   433,   435,   437,
     434,   436,   432,     0,     0,     0,     0,   414,   412,   413,
     411,   445,   159,   274,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   310,     0,     0,     0,     0,     0,   150,
     100,   168,   322,   321,   319,   324,   323,   320,   325,   326,
     327,     0,   327,   137,   139,   193,   478,   480,   484,   488,
     482,   486,   490,   518,   520,     0,     0,     0,   425,     0,
       0,     0,     0,   288,   278,   279,   280,   281,   289,   290,
     291,     0,   301,     0,   313,   240,   302,   157,   148,     0,
     170,     0,   329,   202,   329,   416,   235,   236,   407,   408,
     409,   410,     0,     0,     0,   151,     0,   315,   142,   300,
     307,   149,     0,   328,     0,   152,     0,     0,     0,     0,
       0,     0,   332,     0,   330,     0,   331
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -480,  -480,  -480,   -32,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,   -96,  -308,  -480,
    -480,  -480,  -480,  -480,  -480,  -386,    26,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,    17,  -480,  -480,
    -480,  -480,  -480,  -480,   510,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,   -41,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,   -97,  -480,  -480,    61,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,   566,    66,  -480,  -480,
    -480,  -480,   -93,  -480,    68,  -480,    67,  -480,    64,  -164,
    -480,  -480,  -149,  -480,   282,  -110,  -480,   -12,    -4,  -134,
    -480,   -37,  -480,  -480,  -480,  -480,   554,   -59,  -143,  -183,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -170,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,  -480,
    -480,  -480,  -480,  -480,  -480,  -480,  -151,     4,   219,  -122,
    -480,  -479,  -480,  -480,  -480,  -480,   -85,  -480,    13,   526,
    -167,    25,  -480,  -480
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,   112,    14,    15,    33,   306,    16,    17,
      18,    19,   202,   203,   381,   204,   435,    98,    99,    20,
     205,   383,   617,    21,   206,   621,    53,    22,    23,    24,
      25,    26,    27,   207,   208,   436,   647,   648,   209,   210,
     211,   212,   213,   214,   432,   215,   216,   217,    28,   613,
      29,   109,   614,   894,   828,    30,    31,   106,   612,   827,
     701,   218,   219,   313,   220,   221,   222,   223,   747,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   434,   643,   644,   236,   399,   400,    32,   237,   238,
     239,   240,   241,   242,   243,   244,   387,   388,   245,   246,
     247,   248,   384,   401,   402,   407,   408,   412,   413,   447,
     403,   858,   668,   409,   100,   101,   324,   314,   108,   391,
     754,   103,   585,   590,   734,   249,   418,   840,   882,   897,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     498,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   499,   449,   450,   483,
     452,   453,   454,   455,   456,   457,   656,   474,   458,   519,
     485,   501,   502,   503
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     107,   305,   312,   487,   102,   104,   510,   622,   390,   390,
     315,   316,   471,   624,   670,   626,   404,   557,   410,   414,
     524,   629,   489,   491,   110,   511,   631,   505,   504,   398,
     670,   531,   309,   310,   311,   451,   451,   451,  -297,  -215,
    -234,   451,  -224,  -297,  -297,  -215,  -234,   437,  -224,   317,
     307,  -238,   506,   508,   512,  -228,   451,  -238,  -231,  -232,
     105,  -228,   507,   505,  -231,  -232,   416,   465,   509,   913,
     522,   451,   914,   417,   505,    56,   473,   451,     3,   451,
     386,   392,   392,   437,   395,   376,   490,   492,   521,   405,
     762,   411,   415,   477,   478,    54,   729,   523,   318,   420,
     421,   730,   382,   781,   782,    95,    96,   493,   505,   427,
     428,   425,   385,   325,   505,   406,   394,   326,   396,   397,
     419,   832,   833,   834,   835,   836,   837,   838,   839,   477,
     478,    86,    56,    88,    89,    90,    91,    92,   424,    94,
     327,    95,    96,    97,   370,   371,   372,   373,   374,   377,
     308,   375,   871,   477,   478,  -314,   385,   872,   767,   768,
    -314,   769,   461,   463,    56,   440,   328,   475,   372,   373,
     374,   583,   329,   375,   330,   795,   331,   385,   378,   484,
     856,   857,   513,   486,   906,   907,   500,   332,    86,   333,
      88,    89,    90,    91,    92,   334,    94,   529,   525,   335,
     526,   440,   527,   535,   528,   538,   429,   430,   431,   532,
     533,   534,   440,   537,   515,   516,   517,   336,   518,   337,
      86,   111,    88,    89,    90,    91,    92,   338,    94,   547,
     552,   440,   441,   442,   443,   444,   445,   446,    95,    96,
      97,  -297,  -215,  -234,   339,  -224,   440,   340,   702,   341,
     342,   467,   440,   343,  -238,   344,   345,   760,  -228,   346,
     347,  -231,  -232,   468,   469,   470,   348,   440,   441,   442,
     443,   444,   445,   446,   553,   479,   480,   481,   482,   763,
     764,   765,   349,   766,   479,   480,   481,   482,   558,   559,
     560,   440,   441,   442,   443,   444,   445,   446,   350,   494,
     495,   496,   497,   351,   352,   353,   354,   855,   578,   579,
     580,   581,   582,   584,   586,   587,   588,   589,   591,   592,
     355,   356,   380,   422,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   642,   319,
     320,   321,   322,   323,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   619,   379,   375,   423,   554,   375,
     556,   831,   540,   541,   542,   543,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,   615,   462,   464,   616,
     618,   632,   476,   620,   623,   625,   627,   628,   630,   636,
     633,   634,   635,   637,   544,   545,   638,   514,   639,   645,
     389,   389,   646,   649,   650,   651,   652,   653,   389,   654,
     389,   389,   530,   655,   657,   658,   659,   660,   536,   661,
     539,   367,   368,   369,   370,   371,   372,   373,   374,   641,
     671,   375,   672,   673,   674,   675,   676,   677,   678,   448,
     448,   448,   742,   472,   679,   448,   680,   681,   683,   684,
     682,   685,   686,   472,   472,   687,   738,   763,   703,   704,
     448,   705,   706,   748,   546,   707,   448,   708,   709,   710,
     753,   711,   712,   713,   714,   448,   715,   448,   716,   717,
     718,   448,   719,   448,   724,   720,   725,   773,   770,   772,
     726,   727,   728,    34,   731,   733,   804,   732,   735,    35,
     737,   736,   740,   692,   693,   694,   691,   798,   775,   751,
     390,   776,   777,   797,   699,   404,   809,   756,   410,   758,
     414,   759,   788,   789,   791,   793,   799,   398,   762,   755,
     778,   779,   780,   783,   784,   810,   688,   689,   690,   785,
     787,   803,   805,   695,   696,   697,   698,   806,   700,   509,
     825,   813,   830,   794,   796,   841,   802,   860,   846,   847,
     853,   848,   807,   808,   849,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,   850,
     851,   739,   852,   392,   854,   859,   861,   863,   405,   864,
     881,   411,   862,   415,   865,   866,   867,    50,    51,   868,
     873,   869,   870,   357,   741,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   876,   879,   375,   575,   576,   577,   878,   885,   752,
     889,   743,   891,   899,   902,   900,   903,   904,   908,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   909,   433,
     912,   916,   845,   642,   761,   771,   880,    52,   774,   812,
     548,   549,   550,   551,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,   745,   393,   744,   819,   820,   821,
     800,   874,   823,   746,   750,   749,   824,   842,   426,   884,
     811,   898,   801,     0,     0,     0,   520,     0,     0,   814,
     815,   816,   817,   818,   640,   390,     0,     0,     0,     0,
     843,   844,     0,   822,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   826,     0,     0,   829,   888,     0,   890,
       0,     0,     0,     0,     0,     0,     0,     0,   320,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    55,    56,     0,     0,     0,     0,     0,    57,     0,
       0,   466,     0,     0,     0,   669,     0,     0,     0,     0,
      59,    60,     0,     0,     0,     0,     0,     0,   875,     0,
      61,   669,     0,    62,    63,   877,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,     0,    95,    96,
      97,     0,   757,     0,     0,     0,   893,   883,     0,     0,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,     0,   892,
     375,     0,   901,     0,     0,     0,     0,     0,     0,   896,
       0,     0,     0,     0,     0,   895,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,     0,     0,   375,     0,   910,   911,   905,     0,
       0,   915,   389,     0,     0,     0,     0,   389,     0,   448,
     389,     0,   389,     0,     0,     0,   448,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   575,   576,   448,   448,     0,     0,     0,   472,
       0,     0,   472,   472,     0,     0,     0,     0,     0,     0,
      55,    56,   467,   472,   472,   472,   472,    57,     0,   448,
      58,   488,     0,     0,   468,   469,   470,     0,     0,    59,
      60,     0,     0,     0,     0,     0,     0,     0,     0,    61,
       0,     0,    62,    63,     0,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,     0,    95,    96,    97,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    -2,     4,     0,     0,     0,     0,
       0,     5,     0,     0,     0,     0,   -38,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     576,     0,     0,     0,     0,     0,     0,     0,   601,   -38,
     555,   -38,     0,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,     0,     0,   375,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     6,   -38,     7,     0,   389,   -38,     0,
       0,     0,   448,     0,     0,     0,     0,     0,     0,     0,
       0,   -38,   -38,   -38,   -38,   -38,   -38,   -38,     8,     9,
      10,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   886,   887,
       0,    11,     0,   -38,   -38,   -38,   -38,   -38,   -38,    12,
      13,   -38,   -38,   -38,   -38,   -38,   -38,     0,   -38,   -38,
     -38,   -38,   -38,     0,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,   -38,   -38,     0,     0,     0,     0,     0,     0,     0,
       0,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,   -38,   -38,   -38,   -38,   -38,    55,    56,     0,     0,
       0,     0,     0,    57,     0,     0,   466,     0,     0,     0,
       0,     0,     0,   -38,     0,    59,    60,     0,     0,     0,
       0,     0,     0,     0,     0,    61,     0,     0,    62,    63,
       0,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,     0,    95,    96,    97,    55,    56,     0,     0,
       0,     0,     0,    57,     0,     0,    58,     0,     0,     0,
       0,     0,     0,     0,     0,    59,    60,     0,     0,     0,
       0,     0,     0,     0,     0,    61,     0,     0,    62,    63,
       0,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,   662,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,     0,    95,    96,    97,   721,     0,     0,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,     0,   375,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    55,    56,     0,     0,     0,   437,     0,
      57,     0,     0,    58,     0,     0,     0,   467,     0,     0,
       0,     0,    59,    60,     0,     0,     0,     0,     0,   468,
     469,   470,    61,     0,     0,    62,    63,     0,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,   438,   439,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,     0,
      95,    96,    97,     0,     0,     0,     0,     0,     0,     0,
       0,    55,    56,     0,     0,     0,     0,   442,    57,     0,
       0,    58,     0,   663,   664,     0,   665,   666,   667,     0,
      59,    60,     0,     0,     0,     0,     0,     0,     0,     0,
      61,     0,     0,    62,    63,     0,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,     0,    95,    96,
      97,   722,     0,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,     0,     0,   375,     0,     0,     0,     0,     0,
      55,    56,     0,     0,     0,     0,     0,    57,     0,     0,
      58,     0,   440,   441,   442,   443,   444,   445,   446,    59,
      60,     0,   459,   460,     0,     0,     0,     0,     0,    61,
       0,     0,    62,    63,     0,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,     0,    95,    96,    97,
       0,    55,    56,     0,     0,     0,     0,     0,    57,     0,
       0,    58,     0,     0,     0,     0,     0,     0,     0,     0,
      59,    60,     0,     0,     0,     0,     0,   763,   764,   765,
      61,   766,     0,    62,    63,     0,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,     0,    95,    96,
      97,   723,     0,     0,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,     0,     0,   375,     0,     0,     0,     0,     0,
      55,    56,     0,     0,     0,     0,     0,    57,     0,     0,
      58,     0,     0,     0,     0,     0,     0,     0,     0,    59,
      60,     0,     0,     0,     0,     0,     0,   767,   768,    61,
     769,     0,    62,    63,     0,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,     0,    95,    96,    97,
      55,    56,     0,     0,     0,     0,     0,    57,     0,     0,
      58,     0,     0,     0,     0,     0,     0,     0,     0,    59,
      60,     0,     0,     0,     0,     0,     0,     0,     0,    61,
       0,   790,    62,    63,     0,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,     0,    95,    96,    97,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,     0,     0,
     375,     0,     0,     0,     0,    55,    56,     0,     0,     0,
     437,     0,    57,     0,     0,    58,     0,     0,     0,     0,
       0,     0,     0,     0,    59,    60,     0,     0,     0,     0,
       0,     0,     0,     0,    61,     0,     0,    62,    63,   792,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,   438,   439,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,     0,    95,    96,    97,     0,    55,    56,     0,     0,
       0,   493,     0,    57,     0,     0,    58,     0,     0,     0,
       0,     0,     0,     0,     0,    59,    60,     0,     0,     0,
       0,     0,     0,     0,     0,    61,     0,   767,    62,    63,
       0,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,   438,   439,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,     0,    95,    96,    97,   357,   358,   359,   360,
     361,   362,   363,   364,   786,   366,   367,   368,   369,   370,
     371,   372,   373,   374,     0,     0,   375,     0,     0,     0,
       0,     0,    55,    56,     0,     0,     0,     0,     0,    57,
       0,     0,    58,     0,     0,     0,     0,     0,     0,     0,
       0,    59,    60,     0,   440,   441,   442,   443,   444,   445,
     446,    61,     0,     0,    62,    63,     0,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,   662,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,     0,    95,
      96,    97,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   113,     0,   114,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   440,   441,   442,   443,   444,
     445,   446,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   115,     0,     0,
       0,   116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,   118,   119,   120,   121,   122,
     123,     0,     0,     0,   124,   125,   126,   127,   128,   129,
     130,     0,     0,     0,     0,     0,   131,   132,   133,   134,
     135,   136,     0,     0,   137,   138,   139,   140,   141,   142,
       0,   143,   144,   145,   146,   147,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   156,     0,     0,     0,     0,
       0,     0,     0,   442,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201
};

static const yytype_int16 yycheck[] =
{
      12,    33,    39,   170,     8,     9,   176,   393,   118,   119,
      51,    52,   161,   399,   493,   401,   126,   325,   128,   129,
     184,   407,   171,   172,    12,   176,   412,    54,     8,   125,
     509,   195,    36,    37,    38,   157,   158,   159,     6,     6,
       6,   163,     6,    11,    12,    12,    12,     8,    12,    53,
       7,     6,   174,   175,   176,     6,   178,    12,     6,     6,
      12,    12,     8,    54,    12,    12,   104,   160,     8,     6,
      13,   193,     9,   111,    54,     4,   161,   199,     0,   201,
     117,   118,   119,     8,   121,    12,   171,   172,   181,   126,
       9,   128,   129,    54,    55,     7,     6,   182,     7,   136,
     137,    11,   114,    22,    23,    70,    71,     8,    54,   146,
     147,   143,   116,    10,    54,   127,   120,    10,   122,   123,
     132,   139,   140,   141,   142,   143,   144,   145,   146,    54,
      55,    60,     4,    62,    63,    64,    65,    66,   142,    68,
      10,    70,    71,    72,    27,    28,    29,    30,    31,    12,
     107,    34,     6,    54,    55,     6,   160,    11,   200,   201,
      11,   203,   158,   159,     4,   192,    10,   163,    29,    30,
      31,    11,    10,    34,    10,   202,    10,   181,    70,   166,
      22,    23,   178,   170,    36,    37,   173,    10,    60,    10,
      62,    63,    64,    65,    66,    10,    68,   193,   185,    10,
     187,   192,   189,   199,   191,   201,   127,   128,   129,   196,
     197,   198,   192,   200,   199,   200,   201,    10,   203,    10,
      60,   209,    62,    63,    64,    65,    66,    10,    68,   203,
     204,   192,   193,   194,   195,   196,   197,   198,    70,    71,
      72,   209,   209,   209,    10,   209,   192,    10,   556,    10,
      10,   194,   192,    10,   209,    10,    10,   643,   209,    10,
      10,   209,   209,   206,   207,   208,    10,   192,   193,   194,
     195,   196,   197,   198,   306,   200,   201,   202,   203,   199,
     200,   201,    10,   203,   200,   201,   202,   203,   325,   326,
     327,   192,   193,   194,   195,   196,   197,   198,    10,   200,
     201,   202,   203,    10,    10,    10,    10,   786,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      10,    10,    70,    70,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   434,    57,
      58,    59,    60,    61,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,   386,    12,    34,    70,    12,    34,
      10,   747,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    70,   158,   159,     6,
       6,   418,   163,     6,     6,     6,     6,     6,     6,   426,
       6,     6,     6,     6,   105,   106,     6,   178,     6,    70,
     118,   119,     4,   203,    10,    10,     6,     6,   126,     6,
     128,   129,   193,     6,     6,    10,    10,     6,   199,     6,
     201,    24,    25,    26,    27,    28,    29,    30,    31,   433,
       6,    34,     6,     6,     6,     6,     6,     6,     6,   157,
     158,   159,     4,   161,   203,   163,    10,     6,     6,     6,
     203,     6,     6,   171,   172,     6,    12,   199,    11,    11,
     178,    11,    11,   627,   175,    11,   184,    11,    11,    11,
     634,    11,    11,     6,     6,   193,     6,   195,     6,     6,
      11,   199,    11,   201,     6,    11,     6,   654,   652,   653,
       6,     6,    11,     1,    11,     6,     8,    11,    11,     7,
       6,    11,     6,   544,   545,   546,   543,   677,   657,     6,
     620,   660,   661,   677,   551,   625,   686,     6,   628,     6,
     630,     6,   671,   672,   673,   674,   677,   623,     9,    70,
      10,     9,     9,     9,     9,   686,   540,   541,   542,     9,
       9,     9,     9,   547,   548,   549,   550,     8,   552,     8,
       6,    11,     6,   675,   676,     6,   678,   203,    11,    11,
       9,    11,   684,   685,    11,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    11,
      11,   613,    11,   620,     9,     6,     6,    11,   625,    11,
       8,   628,   203,   630,    11,    11,    11,   105,   106,    11,
       6,    11,    11,    14,   616,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    11,     6,    34,   342,   343,   344,    12,     9,   633,
       9,   618,     9,    11,     6,    11,     9,     6,     8,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,     8,   149,
       9,     9,   759,   759,   647,   652,   830,   175,   655,   701,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,   623,   119,   620,   724,   725,   726,
     677,   825,   729,   625,   630,   628,   733,   756,   144,   842,
     687,   884,   677,    -1,    -1,    -1,   180,    -1,    -1,   713,
     714,   715,   716,   717,   432,   825,    -1,    -1,    -1,    -1,
     757,   758,    -1,   727,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   737,    -1,    -1,   740,   859,    -1,   861,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,   493,    -1,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    -1,    -1,    -1,   825,    -1,
      32,   509,    -1,    35,    36,   827,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,     6,    -1,    -1,    -1,   873,   841,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,   871,
      34,    -1,   894,    -1,    -1,    -1,    -1,    -1,    -1,   881,
      -1,    -1,    -1,    -1,    -1,   879,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    34,    -1,   908,   909,   902,    -1,
      -1,   913,   620,    -1,    -1,    -1,    -1,   625,    -1,   627,
     628,    -1,   630,    -1,    -1,    -1,   634,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   650,   651,   652,   653,    -1,    -1,    -1,   657,
      -1,    -1,   660,   661,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,   194,   671,   672,   673,   674,    10,    -1,   677,
      13,   203,    -1,    -1,   206,   207,   208,    -1,    -1,    22,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    -1,    35,    36,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     0,     1,    -1,    -1,    -1,    -1,
      -1,     7,    -1,    -1,    -1,    -1,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     778,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   786,    35,
      11,    37,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    69,    70,    71,    -1,   825,    74,    -1,
      -1,    -1,   830,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   856,   857,
      -1,   107,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,     3,     4,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    35,    36,
      -1,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    -1,    70,    71,    72,     3,     4,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    35,    36,
      -1,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    -1,    70,    71,    72,    11,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,    -1,    -1,    -1,     8,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,   194,    -1,    -1,
      -1,    -1,    22,    23,    -1,    -1,    -1,    -1,    -1,   206,
     207,   208,    32,    -1,    -1,    35,    36,    -1,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    -1,
      70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,    -1,    -1,    -1,    -1,   194,    10,    -1,
      -1,    13,    -1,   200,   201,    -1,   203,   204,   205,    -1,
      22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      32,    -1,    -1,    35,    36,    -1,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    11,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,
       3,     4,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,   192,   193,   194,   195,   196,   197,   198,    22,
      23,    -1,   202,   203,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    -1,    35,    36,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    -1,    70,    71,    72,
      -1,     3,     4,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    -1,    -1,   199,   200,   201,
      32,   203,    -1,    35,    36,    -1,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    11,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,
       3,     4,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    -1,    -1,    -1,    -1,    -1,   200,   201,    32,
     203,    -1,    35,    36,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    -1,    70,    71,    72,
       3,     4,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,   203,    35,    36,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    -1,    70,    71,    72,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    -1,
      34,    -1,    -1,    -1,    -1,     3,     4,    -1,    -1,    -1,
       8,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    -1,    -1,    35,    36,   202,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,     3,     4,    -1,    -1,
      -1,     8,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,   200,    35,    36,
      -1,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    -1,    70,    71,    72,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    34,    -1,    -1,    -1,
      -1,    -1,     3,     4,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,   192,   193,   194,   195,   196,   197,
     198,    32,    -1,    -1,    35,    36,    -1,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    -1,    70,
      71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    35,    -1,    37,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   192,   193,   194,   195,   196,
     197,   198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,
      -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    88,    89,    90,    91,    92,
      93,    -1,    -1,    -1,    97,    98,    99,   100,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   211,   212,     0,     1,     7,    69,    71,    94,    95,
      96,   107,   115,   116,   214,   215,   218,   219,   220,   221,
     229,   233,   237,   238,   239,   240,   241,   242,   258,   260,
     265,   266,   297,   216,     1,     7,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
     105,   106,   175,   236,     7,     3,     4,    10,    13,    22,
      23,    32,    35,    36,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    70,    71,    72,   227,   228,
     324,   325,   328,   331,   328,    12,   267,   327,   328,   261,
      12,   209,   213,    35,    37,    70,    74,    87,    88,    89,
      90,    91,    92,    93,    97,    98,    99,   100,   101,   102,
     103,   109,   110,   111,   112,   113,   114,   117,   118,   119,
     120,   121,   122,   124,   125,   126,   127,   128,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   222,   223,   225,   230,   234,   243,   244,   248,
     249,   250,   251,   252,   253,   255,   256,   257,   271,   272,
     274,   275,   276,   277,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   294,   298,   299,   300,
     301,   302,   303,   304,   305,   308,   309,   310,   311,   335,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   213,   217,     7,   107,   328,
     328,   328,   331,   273,   327,   273,   273,   328,     7,   324,
     324,   324,   324,   324,   326,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    34,    12,    12,    70,    12,
      70,   224,   327,   231,   312,   328,   331,   306,   307,   324,
     325,   329,   331,   306,   328,   331,   328,   328,   227,   295,
     296,   313,   314,   320,   325,   331,   327,   315,   316,   323,
     325,   331,   317,   318,   325,   331,   104,   111,   336,   327,
     331,   331,    70,    70,   328,   213,   336,   331,   331,   127,
     128,   129,   254,   254,   291,   226,   245,     8,    54,    55,
     192,   193,   194,   195,   196,   197,   198,   319,   324,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   408,   202,
     203,   397,   398,   397,   398,   312,    13,   194,   206,   207,
     208,   322,   324,   406,   407,   397,   398,    54,    55,   200,
     201,   202,   203,   399,   408,   410,   408,   410,   203,   322,
     406,   322,   406,     8,   200,   201,   202,   203,   360,   396,
     408,   411,   412,   413,     8,    54,   399,     8,   399,     8,
     360,   396,   399,   397,   398,   199,   200,   201,   203,   409,
     409,   312,    13,   406,   319,   408,   408,   408,   408,   397,
     398,   319,   408,   408,   408,   397,   398,   408,   397,   398,
      73,    74,    75,    76,   105,   106,   175,   236,    73,    74,
      75,    76,   236,   213,    12,    11,    10,   228,   331,   331,
     331,   328,   328,   328,   328,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   324,   324,   324,   331,   331,
     331,   331,   331,    11,   331,   332,   331,   331,   331,   331,
     333,   331,   331,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   268,   259,   262,    70,     6,   232,     6,   213,
       6,   235,   235,     6,   235,     6,   235,     6,     6,   235,
       6,   235,   331,     6,     6,     6,   331,     6,     6,     6,
     324,   328,   227,   292,   293,    70,     4,   246,   247,   203,
      10,    10,     6,     6,     6,     6,   406,     6,    10,    10,
       6,     6,    55,   200,   201,   203,   204,   205,   322,   324,
     401,     6,     6,     6,     6,     6,     6,     6,     6,   203,
      10,     6,   203,     6,     6,     6,     6,     6,   328,   328,
     328,   331,   273,   273,   273,   328,   328,   328,   328,   331,
     328,   270,   228,    11,    11,    11,    11,    11,    11,    11,
      11,    11,    11,     6,     6,     6,     6,     6,    11,    11,
      11,    11,    11,    11,     6,     6,     6,     6,    11,     6,
      11,    11,    11,     6,   334,    11,    11,     6,    12,   213,
       6,   327,     4,   408,   307,   296,   314,   278,   319,   316,
     318,     6,   328,   319,   330,    70,     6,     6,     6,     6,
     235,   247,     9,   199,   200,   201,   203,   200,   201,   203,
     319,   408,   319,   410,   408,   322,   322,   322,    10,     9,
       9,    22,    23,     9,     9,     9,    22,     9,   322,   322,
     203,   322,   202,   322,   399,   202,   399,   319,   360,   396,
     408,   411,   399,     9,     8,     9,     8,   399,   399,   360,
     396,   408,   213,    11,   328,   328,   328,   328,   328,   331,
     331,   331,   328,   331,   331,     6,   328,   269,   264,   328,
       6,   235,   139,   140,   141,   142,   143,   144,   145,   146,
     337,     6,   337,   331,   331,   293,    11,    11,    11,    11,
      11,    11,    11,     9,     9,   401,    22,    23,   321,     6,
     203,     6,   203,    11,    11,    11,    11,    11,    11,    11,
      11,     6,    11,     6,   329,   331,    11,   213,    12,     6,
     319,     8,   338,   328,   338,     9,   324,   324,   399,     9,
     399,     9,   327,   331,   263,   328,   327,   339,   339,    11,
      11,   213,     6,     9,     6,   328,    36,    37,     8,     8,
     327,   327,     9,     6,     9,   327,     9
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   210,   211,   212,   212,   213,   213,   214,   214,   214,
     214,   214,   215,   215,   216,   215,   217,   215,   218,   218,
     218,   218,   218,   218,   218,   218,   219,   220,   221,   222,
     224,   223,   226,   225,   227,   227,   228,   228,   229,   229,
     229,   229,   229,   229,   229,   231,   230,   232,   232,   233,
     233,   233,   233,   233,   233,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   235,
     235,   236,   236,   236,   236,   236,   236,   236,   236,   236,
     236,   237,   238,   238,   238,   239,   240,   241,   242,   243,
     243,   245,   244,   246,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   254,   254,   254,   255,   255,   255,   255,
     256,   256,   257,   257,   259,   258,   261,   262,   263,   260,
     264,   264,   264,   265,   267,   268,   269,   266,   270,   266,
     271,   272,   273,   273,   274,   275,   276,   277,   277,   278,
     278,   279,   279,   280,   280,   281,   281,   282,   283,   284,
     284,   284,   284,   284,   284,   285,   286,   287,   288,   289,
     291,   290,   292,   292,   293,   294,   295,   295,   296,   297,
     298,   298,   298,   299,   300,   300,   301,   302,   303,   304,
     305,   305,   306,   306,   307,   307,   308,   309,   310,   311,
     312,   313,   313,   314,   314,   315,   315,   316,   316,   317,
     317,   318,   318,   319,   320,   321,   321,   322,   323,   324,
     324,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   326,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   325,   325,   325,   325,   325,
     325,   325,   325,   325,   325,   327,   328,   329,   330,   331,
     331,   331,   331,   331,   331,   331,   331,   331,   331,   332,
     332,   333,   334,   334,   334,   335,   336,   336,   336,   337,
     337,   337,   337,   337,   337,   337,   337,   338,   338,   339,
     339,   339,   339,   340,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   341,
     341,   342,   342,   342,   342,   343,   343,   344,   345,   345,
     346,   347,   347,   348,   349,   350,   350,   351,   352,   353,
     354,   354,   355,   355,   355,   356,   356,   357,   357,   358,
     358,   359,   359,   359,   359,   360,   360,   361,   361,   361,
     361,   361,   361,   361,   361,   362,   362,   363,   363,   364,
     364,   365,   366,   367,   367,   368,   368,   368,   369,   369,
     370,   371,   371,   372,   373,   374,   375,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   386,
     387,   388,   389,   390,   391,   392,   392,   393,   393,   394,
     395,   395,   396,   397,   397,   398,   398,   399,   399,   400,
     400,   401,   401,   402,   402,   403,   403,   404,   404,   405,
     405,   406,   406,   407,   407,   407,   407,   408,   408,   408,
     408,   408,   408,   408,   408,   409,   409,   409,   409,   410,
     410,   410,   410,   411,   411,   411,   411,   412,   412,   413,
     413
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     2,     2,
       2,     1,     2,     1,     0,     3,     0,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     2,     1,
       0,     3,     0,     3,     1,     1,     1,     1,     0,     1,
       1,     2,     2,     3,     3,     0,     3,     0,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       4,     0,     3,     1,     2,     1,     1,     1,     1,     1,
       2,     2,     0,     2,     2,     2,     3,     5,     3,     5,
       1,     2,     7,     1,     0,     5,     0,     0,     0,     9,
       1,     3,     5,     3,     0,     0,     0,     7,     0,     6,
       2,     1,     0,     1,     1,     1,     1,     2,     5,     1,
       3,     1,     3,     1,     3,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       0,     4,     1,     3,     1,     3,     1,     3,     1,     4,
       2,     4,     6,     4,     2,     4,     2,     1,     1,     3,
       1,     3,     1,     3,     1,     1,     2,     2,     2,     2,
       1,     1,     3,     1,     1,     1,     3,     1,     1,     1,
       3,     1,     1,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     2,     4,     4,     4,     4,
       4,     4,     4,     0,     5,     4,     4,     4,     6,     6,
       6,     6,     4,     4,     4,     4,     4,     4,     6,     6,
       6,     6,     4,     4,     3,     1,     1,     1,     1,     1,
       8,     6,     6,     3,     4,     4,     4,     8,     4,     1,
       3,     2,     0,     3,     3,     7,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     3,     0,
       6,     8,     6,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     4,     4,     2,     2,     4,     2,     4,
       1,     2,     2,     1,     1,     2,     2,     1,     1,     1,
       2,     2,     2,     4,     2,     2,     4,     6,     6,     6,
       6,     4,     4,     4,     4,     3,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     5,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       1,     2,     2,     2,     2,     4,     1,     2,     1,     2,
       1,     2,     1,     2,     1,     2,     1,     2,     2,     2,
       1,     4,     2,     2,     2,     1,     2,     2,     2,     2,
       2,     2,     3,     1,     3,     1,     3,     1,     4,     1,
       4,     1,     4,     1,     4,     1,     4,     1,     4,     1,
       4,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     3,     4,     3,
       4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        YY_LAC_DISCARD ("YYBACKUP");                              \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return YYENOMEM if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYPTRDIFF_T *yycapacity, YYPTRDIFF_T yyadd,
#if YYDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yy_state_t **yybottom,
                      yy_state_t *yybottom_no_free,
                      yy_state_t **yytop, yy_state_t *yytop_empty)
{
  YYPTRDIFF_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYPTRDIFF_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYPTRDIFF_T yyalloc = 2 * yysize_new;
      yy_state_t *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        YY_CAST (yy_state_t *,
                 YYSTACK_ALLOC (YY_CAST (YYSIZE_T,
                                         yyalloc * YYSIZEOF (*yybottom_new))));
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                                \
do {                                                                    \
  if (!yy_lac_established)                                              \
    {                                                                   \
      YYDPRINTF ((stderr,                                               \
                  "LAC: initial context established for %s\n",          \
                  yysymbol_name (yytoken)));                            \
      yy_lac_established = 1;                                           \
      switch (yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken))    \
        {                                                               \
        case YYENOMEM:                                                  \
          goto yyexhaustedlab;                                          \
        case 1:                                                         \
          goto yyerrlab;                                                \
        }                                                               \
    }                                                                   \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if YYDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      YYDPRINTF ((stderr, "LAC: initial context discarded due to "       \
                  Event "\n"));                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return YYENOMEM if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yy_state_t *yyesa, yy_state_t **yyes,
        YYPTRDIFF_T *yyes_capacity, yy_state_t *yyssp, yysymbol_kind_t yytoken)
{
  yy_state_t *yyes_prev = yyssp;
  yy_state_t *yyesp = yyes_prev;
  /* Reduce until we encounter a shift and thereby accept the token.  */
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yysymbol_name (yytoken)));
  if (yytoken == YYSYMBOL_YYUNDEF)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[+*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          /* Use the default action.  */
          yyrule = yydefact[+*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          /* Use the action from yytable.  */
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      /* By now we know we have to simulate a reduce.  */
      YYDPRINTF ((stderr, " R%d", yyrule - 1));
      {
        /* Pop the corresponding number of values from the stack.  */
        YYPTRDIFF_T yylen = yyr2[yyrule];
        /* First pop from the LAC stack as many tokens as possible.  */
        if (yyesp != yyes_prev)
          {
            YYPTRDIFF_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yyesp = yyes_prev;
                yylen -= yysize;
              }
          }
        /* Only afterwards look at the main stack.  */
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      /* Push the resulting state of the reduction.  */
      {
        yy_state_fast_t yystate;
        {
          const int yylhs = yyr1[yyrule] - YYNTOKENS;
          const int yyi = yypgoto[yylhs] + *yyesp;
          yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyesp
                     ? yytable[yyi]
                     : yydefgoto[yylhs]);
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            YY_IGNORE_USELESS_CAST_BEGIN
            *yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if YYDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return YYENOMEM;
              }
            YY_IGNORE_USELESS_CAST_BEGIN
            *++yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}

/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yy_state_t *yyesa;
  yy_state_t **yyes;
  YYPTRDIFF_T *yyes_capacity;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;

  int yyx;
  for (yyx = 0; yyx < YYNTOKENS; ++yyx)
    {
      yysymbol_kind_t yysym = YY_CAST (yysymbol_kind_t, yyx);
      if (yysym != YYSYMBOL_YYerror && yysym != YYSYMBOL_YYUNDEF)
        switch (yy_lac (yyctx->yyesa, yyctx->yyes, yyctx->yyes_capacity, yyctx->yyssp, yysym))
          {
          case YYENOMEM:
            return YYENOMEM;
          case 1:
            continue;
          default:
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = yysym;
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif



static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else if (yyn == 0)
        YYDPRINTF ((stderr, "No expected tokens.\n"));
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store or if
   yy_lac returned YYENOMEM.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yystrlen (yysymbol_name (yyarg[yyi]));
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp = yystpcpy (yyp, yysymbol_name (yyarg[yyi++]));
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    yy_state_t yyesa[20];
    yy_state_t *yyes = yyesa;
    YYPTRDIFF_T yyes_capacity = 20 < YYMAXDEPTH ? 20 : YYMAXDEPTH;

  /* Whether LAC context is established.  A Boolean.  */
  int yy_lac_established = 0;
  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= T_EOF)
    {
      yychar = T_EOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      YY_LAC_ESTABLISH;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  YY_LAC_DISCARD ("shift");
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
  case 14: /* $@1: %empty  */
#line 712 "src/asm/parser.y"
                        {
			lexer_SetMode(LEXER_NORMAL);
			lexer_ToggleStringExpansion(true);
		}
#line 3349 "src/asm/parser.c"
    break;

  case 15: /* line: error $@1 endofline  */
#line 715 "src/asm/parser.y"
                            {
			fstk_StopRept();
			yyerrok;
		}
#line 3358 "src/asm/parser.c"
    break;

  case 16: /* $@2: %empty  */
#line 720 "src/asm/parser.y"
                                {
			lexer_SetMode(LEXER_NORMAL);
			lexer_ToggleStringExpansion(true);
		}
#line 3367 "src/asm/parser.c"
    break;

  case 17: /* line: "label" error $@2 endofline  */
#line 723 "src/asm/parser.y"
                            {
			struct Symbol *macro = sym_FindExactSymbol((yyvsp[-3].symName));

			if (macro && macro->type == SYM_MACRO)
				fprintf(stderr,
					"    To invoke `%s` as a macro it must be indented\n", (yyvsp[-3].symName));
			fstk_StopRept();
			yyerrok;
		}
#line 3381 "src/asm/parser.c"
    break;

  case 26: /* if: "IF" const "newline"  */
#line 751 "src/asm/parser.y"
                                           {
			lexer_IncIFDepth();

			if ((yyvsp[-1].constValue))
				lexer_RunIFBlock();
			else
				lexer_SetMode(LEXER_SKIP_TO_ELIF);
		}
#line 3394 "src/asm/parser.c"
    break;

  case 27: /* elif: "ELIF" const "newline"  */
#line 761 "src/asm/parser.y"
                                             {
			if (lexer_GetIFDepth() == 0)
				fatalerror("Found ELIF outside an IF construct\n");

			if (lexer_RanIFBlock()) {
				if (lexer_ReachedELSEBlock())
					fatalerror("Found ELIF after an ELSE block\n");

				lexer_SetMode(LEXER_SKIP_TO_ENDC);
			} else if ((yyvsp[-1].constValue)) {
				lexer_RunIFBlock();
			} else {
				lexer_SetMode(LEXER_SKIP_TO_ELIF);
			}
		}
#line 3414 "src/asm/parser.c"
    break;

  case 28: /* else: "ELSE" "newline"  */
#line 778 "src/asm/parser.y"
                                       {
			if (lexer_GetIFDepth() == 0)
				fatalerror("Found ELSE outside an IF construct\n");

			if (lexer_RanIFBlock()) {
				if (lexer_ReachedELSEBlock())
					fatalerror("Found ELSE after an ELSE block\n");

				lexer_SetMode(LEXER_SKIP_TO_ENDC);
			} else {
				lexer_RunIFBlock();
				lexer_ReachELSEBlock();
			}
		}
#line 3433 "src/asm/parser.c"
    break;

  case 29: /* endc: "ENDC"  */
#line 794 "src/asm/parser.y"
                             {
			lexer_DecIFDepth();
		}
#line 3441 "src/asm/parser.c"
    break;

  case 30: /* $@3: %empty  */
#line 799 "src/asm/parser.y"
                           {
			lexer_ToggleStringExpansion(false);
		}
#line 3449 "src/asm/parser.c"
    break;

  case 31: /* def_id: "DEF" $@3 "identifier"  */
#line 801 "src/asm/parser.y"
                       {
			lexer_ToggleStringExpansion(true);
			strcpy((yyval.symName), (yyvsp[0].symName));
		}
#line 3458 "src/asm/parser.c"
    break;

  case 32: /* $@4: %empty  */
#line 807 "src/asm/parser.y"
                              {
			lexer_ToggleStringExpansion(false);
		}
#line 3466 "src/asm/parser.c"
    break;

  case 33: /* redef_id: "REDEF" $@4 "identifier"  */
#line 809 "src/asm/parser.y"
                       {
			lexer_ToggleStringExpansion(true);
			strcpy((yyval.symName), (yyvsp[0].symName));
		}
#line 3475 "src/asm/parser.c"
    break;

  case 39: /* label: ":"  */
#line 819 "src/asm/parser.y"
                          {
			sym_AddAnonLabel();
		}
#line 3483 "src/asm/parser.c"
    break;

  case 40: /* label: "local identifier"  */
#line 822 "src/asm/parser.y"
                             {
			sym_AddLocalLabel((yyvsp[0].symName));
		}
#line 3491 "src/asm/parser.c"
    break;

  case 41: /* label: "local identifier" ":"  */
#line 825 "src/asm/parser.y"
                                     {
			sym_AddLocalLabel((yyvsp[-1].symName));
		}
#line 3499 "src/asm/parser.c"
    break;

  case 42: /* label: "label" ":"  */
#line 828 "src/asm/parser.y"
                                  {
			sym_AddLabel((yyvsp[-1].symName));
		}
#line 3507 "src/asm/parser.c"
    break;

  case 43: /* label: "local identifier" ":" ":"  */
#line 831 "src/asm/parser.y"
                                             {
			sym_AddLocalLabel((yyvsp[-2].symName));
			sym_Export((yyvsp[-2].symName));
		}
#line 3516 "src/asm/parser.c"
    break;

  case 44: /* label: "label" ":" ":"  */
#line 835 "src/asm/parser.y"
                                          {
			sym_AddLabel((yyvsp[-2].symName));
			sym_Export((yyvsp[-2].symName));
		}
#line 3525 "src/asm/parser.c"
    break;

  case 45: /* $@5: %empty  */
#line 841 "src/asm/parser.y"
                       {
			// Parsing 'macroargs' will restore the lexer's normal mode
			lexer_SetMode(LEXER_RAW);
		}
#line 3534 "src/asm/parser.c"
    break;

  case 46: /* macro: "identifier" $@5 macroargs  */
#line 844 "src/asm/parser.y"
                            {
			fstk_RunMacro((yyvsp[-2].symName), (yyvsp[0].macroArg));
		}
#line 3542 "src/asm/parser.c"
    break;

  case 47: /* macroargs: %empty  */
#line 849 "src/asm/parser.y"
                         {
			(yyval.macroArg) = macro_NewArgs();
		}
#line 3550 "src/asm/parser.c"
    break;

  case 48: /* macroargs: macroargs "string"  */
#line 852 "src/asm/parser.y"
                                     {
			macro_AppendArg(&((yyval.macroArg)), strdup((yyvsp[0].string)));
		}
#line 3558 "src/asm/parser.c"
    break;

  case 101: /* compoundeq: "+="  */
#line 915 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_ADD; }
#line 3564 "src/asm/parser.c"
    break;

  case 102: /* compoundeq: "-="  */
#line 916 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_SUB; }
#line 3570 "src/asm/parser.c"
    break;

  case 103: /* compoundeq: "*="  */
#line 917 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_MUL; }
#line 3576 "src/asm/parser.c"
    break;

  case 104: /* compoundeq: "/="  */
#line 918 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_DIV; }
#line 3582 "src/asm/parser.c"
    break;

  case 105: /* compoundeq: "%="  */
#line 919 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_MOD; }
#line 3588 "src/asm/parser.c"
    break;

  case 106: /* compoundeq: "^="  */
#line 920 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_XOR; }
#line 3594 "src/asm/parser.c"
    break;

  case 107: /* compoundeq: "|="  */
#line 921 "src/asm/parser.y"
                             { (yyval.compoundEqual) = RPN_OR; }
#line 3600 "src/asm/parser.c"
    break;

  case 108: /* compoundeq: "&="  */
#line 922 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_AND; }
#line 3606 "src/asm/parser.c"
    break;

  case 109: /* compoundeq: "<<="  */
#line 923 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_SHL; }
#line 3612 "src/asm/parser.c"
    break;

  case 110: /* compoundeq: ">>="  */
#line 924 "src/asm/parser.y"
                              { (yyval.compoundEqual) = RPN_SHR; }
#line 3618 "src/asm/parser.c"
    break;

  case 111: /* equ: "label" "EQU" const  */
#line 927 "src/asm/parser.y"
                                          { sym_AddEqu((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 3624 "src/asm/parser.c"
    break;

  case 112: /* set: "label" "=" const  */
#line 930 "src/asm/parser.y"
                                            { sym_AddVar((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 3630 "src/asm/parser.c"
    break;

  case 113: /* set: "label" compoundeq const  */
#line 931 "src/asm/parser.y"
                                           { compoundAssignment((yyvsp[-2].symName), (yyvsp[-1].compoundEqual), (yyvsp[0].constValue)); }
#line 3636 "src/asm/parser.c"
    break;

  case 114: /* set: "label" "SET" const  */
#line 932 "src/asm/parser.y"
                                          {
			warning(WARNING_OBSOLETE, "`SET` for variables is deprecated; use `=`\n");
			sym_AddVar((yyvsp[-2].symName), (yyvsp[0].constValue));
		}
#line 3645 "src/asm/parser.c"
    break;

  case 115: /* equs: "label" "EQUS" string  */
#line 938 "src/asm/parser.y"
                                            { sym_AddString((yyvsp[-2].symName), (yyvsp[0].string)); }
#line 3651 "src/asm/parser.c"
    break;

  case 116: /* rb: "label" "RB" rs_uconst  */
#line 941 "src/asm/parser.y"
                                             {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddVar("_RS", sym_GetConstantValue("_RS") + (yyvsp[0].constValue));
		}
#line 3660 "src/asm/parser.c"
    break;

  case 117: /* rw: "label" "RW" rs_uconst  */
#line 947 "src/asm/parser.y"
                                             {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddVar("_RS", sym_GetConstantValue("_RS") + 2 * (yyvsp[0].constValue));
		}
#line 3669 "src/asm/parser.c"
    break;

  case 118: /* rl: "label" "rl" rs_uconst  */
#line 953 "src/asm/parser.y"
                                             {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddVar("_RS", sym_GetConstantValue("_RS") + 4 * (yyvsp[0].constValue));
		}
#line 3678 "src/asm/parser.c"
    break;

  case 119: /* align: "ALIGN" uconst  */
#line 959 "src/asm/parser.y"
                                    {
			if ((yyvsp[0].constValue) > 16)
				error("Alignment must be between 0 and 16, not %u\n", (yyvsp[0].constValue));
			else
				sect_AlignPC((yyvsp[0].constValue), 0);
		}
#line 3689 "src/asm/parser.c"
    break;

  case 120: /* align: "ALIGN" uconst "," uconst  */
#line 965 "src/asm/parser.y"
                                                   {
			if ((yyvsp[-2].constValue) > 16)
				error("Alignment must be between 0 and 16, not %u\n", (yyvsp[-2].constValue));
			else if ((yyvsp[0].constValue) >= 1 << (yyvsp[-2].constValue))
				error("Offset must be between 0 and %u, not %u\n",
					(1 << (yyvsp[-2].constValue)) - 1, (yyvsp[0].constValue));
			else
				sect_AlignPC((yyvsp[-2].constValue), (yyvsp[0].constValue));
		}
#line 3703 "src/asm/parser.c"
    break;

  case 121: /* $@6: %empty  */
#line 976 "src/asm/parser.y"
                            {
			// Parsing 'opt_list' will restore the lexer's normal mode
			lexer_SetMode(LEXER_RAW);
		}
#line 3712 "src/asm/parser.c"
    break;

  case 125: /* opt_list_entry: "string"  */
#line 986 "src/asm/parser.y"
                           { opt_Parse((yyvsp[0].string)); }
#line 3718 "src/asm/parser.c"
    break;

  case 126: /* popo: "POPO"  */
#line 989 "src/asm/parser.y"
                             { opt_Pop(); }
#line 3724 "src/asm/parser.c"
    break;

  case 127: /* pusho: "PUSHO"  */
#line 992 "src/asm/parser.y"
                              { opt_Push(); }
#line 3730 "src/asm/parser.c"
    break;

  case 128: /* pops: "POPS"  */
#line 995 "src/asm/parser.y"
                             { sect_PopSection(); }
#line 3736 "src/asm/parser.c"
    break;

  case 129: /* pushs: "PUSHS"  */
#line 998 "src/asm/parser.y"
                              { sect_PushSection(); }
#line 3742 "src/asm/parser.c"
    break;

  case 130: /* fail: "FAIL" string  */
#line 1001 "src/asm/parser.y"
                                    { fatalerror("%s\n", (yyvsp[0].string)); }
#line 3748 "src/asm/parser.c"
    break;

  case 131: /* warn: "WARN" string  */
#line 1004 "src/asm/parser.y"
                                    { warning(WARNING_USER, "%s\n", (yyvsp[0].string)); }
#line 3754 "src/asm/parser.c"
    break;

  case 132: /* assert_type: %empty  */
#line 1007 "src/asm/parser.y"
                         { (yyval.assertType) = ASSERT_ERROR; }
#line 3760 "src/asm/parser.c"
    break;

  case 133: /* assert_type: "WARN" ","  */
#line 1008 "src/asm/parser.y"
                                     { (yyval.assertType) = ASSERT_WARN; }
#line 3766 "src/asm/parser.c"
    break;

  case 134: /* assert_type: "FAIL" ","  */
#line 1009 "src/asm/parser.y"
                                     { (yyval.assertType) = ASSERT_ERROR; }
#line 3772 "src/asm/parser.c"
    break;

  case 135: /* assert_type: "FATAL" ","  */
#line 1010 "src/asm/parser.y"
                                      { (yyval.assertType) = ASSERT_FATAL; }
#line 3778 "src/asm/parser.c"
    break;

  case 136: /* assert: "ASSERT" assert_type relocexpr  */
#line 1013 "src/asm/parser.y"
                                                     {
			if (!rpn_isKnown(&(yyvsp[0].expr))) {
				if (!out_CreateAssert((yyvsp[-1].assertType), &(yyvsp[0].expr), "",
						      sect_GetOutputOffset()))
					error("Assertion creation failed: %s\n",
						strerror(errno));
			} else if ((yyvsp[0].expr).val == 0) {
				failAssert((yyvsp[-1].assertType));
			}
			rpn_Free(&(yyvsp[0].expr));
		}
#line 3794 "src/asm/parser.c"
    break;

  case 137: /* assert: "ASSERT" assert_type relocexpr "," string  */
#line 1024 "src/asm/parser.y"
                                                                    {
			if (!rpn_isKnown(&(yyvsp[-2].expr))) {
				if (!out_CreateAssert((yyvsp[-3].assertType), &(yyvsp[-2].expr), (yyvsp[0].string),
						      sect_GetOutputOffset()))
					error("Assertion creation failed: %s\n",
						strerror(errno));
			} else if ((yyvsp[-2].expr).val == 0) {
				failAssertMsg((yyvsp[-3].assertType), (yyvsp[0].string));
			}
			rpn_Free(&(yyvsp[-2].expr));
		}
#line 3810 "src/asm/parser.c"
    break;

  case 138: /* assert: "STATIC_ASSERT" assert_type const  */
#line 1035 "src/asm/parser.y"
                                                        {
			if ((yyvsp[0].constValue) == 0)
				failAssert((yyvsp[-1].assertType));
		}
#line 3819 "src/asm/parser.c"
    break;

  case 139: /* assert: "STATIC_ASSERT" assert_type const "," string  */
#line 1039 "src/asm/parser.y"
                                                                       {
			if ((yyvsp[-2].constValue) == 0)
				failAssertMsg((yyvsp[-3].assertType), (yyvsp[0].string));
		}
#line 3828 "src/asm/parser.c"
    break;

  case 140: /* shift: "SHIFT"  */
#line 1045 "src/asm/parser.y"
                              { macro_ShiftCurrentArgs(1); }
#line 3834 "src/asm/parser.c"
    break;

  case 141: /* shift: "SHIFT" const  */
#line 1046 "src/asm/parser.y"
                                    { macro_ShiftCurrentArgs((yyvsp[0].constValue)); }
#line 3840 "src/asm/parser.c"
    break;

  case 142: /* load: "LOAD" sectmod string "," sectiontype sectorg sectattrs  */
#line 1049 "src/asm/parser.y"
                                                                                  {
			sect_SetLoadSection((yyvsp[-4].string), (yyvsp[-2].constValue), (yyvsp[-1].constValue), &(yyvsp[0].sectSpec), (yyvsp[-5].sectMod));
		}
#line 3848 "src/asm/parser.c"
    break;

  case 143: /* load: "ENDL"  */
#line 1052 "src/asm/parser.y"
                             { sect_EndLoadSection(); }
#line 3854 "src/asm/parser.c"
    break;

  case 144: /* @7: %empty  */
#line 1055 "src/asm/parser.y"
                                              {
			(yyval.captureTerminated) = lexer_CaptureRept(&captureBody);
		}
#line 3862 "src/asm/parser.c"
    break;

  case 145: /* rept: "REPT" uconst "newline" @7 endofline  */
#line 1057 "src/asm/parser.y"
                            {
			if ((yyvsp[-1].captureTerminated))
				fstk_RunRept((yyvsp[-3].constValue), captureBody.lineNo, captureBody.body,
					     captureBody.size);
		}
#line 3872 "src/asm/parser.c"
    break;

  case 146: /* $@8: %empty  */
#line 1064 "src/asm/parser.y"
                            {
			lexer_ToggleStringExpansion(false);
		}
#line 3880 "src/asm/parser.c"
    break;

  case 147: /* $@9: %empty  */
#line 1066 "src/asm/parser.y"
                       {
			lexer_ToggleStringExpansion(true);
		}
#line 3888 "src/asm/parser.c"
    break;

  case 148: /* @10: %empty  */
#line 1068 "src/asm/parser.y"
                                             {
			(yyval.captureTerminated) = lexer_CaptureRept(&captureBody);
		}
#line 3896 "src/asm/parser.c"
    break;

  case 149: /* for: "FOR" $@8 "identifier" $@9 "," for_args "newline" @10 endofline  */
#line 1070 "src/asm/parser.y"
                            {
			if ((yyvsp[-1].captureTerminated))
				fstk_RunFor((yyvsp[-6].symName), (yyvsp[-3].forArgs).start, (yyvsp[-3].forArgs).stop, (yyvsp[-3].forArgs).step, captureBody.lineNo,
					    captureBody.body, captureBody.size);
		}
#line 3906 "src/asm/parser.c"
    break;

  case 150: /* for_args: const  */
#line 1076 "src/asm/parser.y"
                        {
			(yyval.forArgs).start = 0;
			(yyval.forArgs).stop = (yyvsp[0].constValue);
			(yyval.forArgs).step = 1;
		}
#line 3916 "src/asm/parser.c"
    break;

  case 151: /* for_args: const "," const  */
#line 1081 "src/asm/parser.y"
                                      {
			(yyval.forArgs).start = (yyvsp[-2].constValue);
			(yyval.forArgs).stop = (yyvsp[0].constValue);
			(yyval.forArgs).step = 1;
		}
#line 3926 "src/asm/parser.c"
    break;

  case 152: /* for_args: const "," const "," const  */
#line 1086 "src/asm/parser.y"
                                                    {
			(yyval.forArgs).start = (yyvsp[-4].constValue);
			(yyval.forArgs).stop = (yyvsp[-2].constValue);
			(yyval.forArgs).step = (yyvsp[0].constValue);
		}
#line 3936 "src/asm/parser.c"
    break;

  case 153: /* break: label "BREAK" endofline  */
#line 1093 "src/asm/parser.y"
                                              {
			if (fstk_Break())
				lexer_SetMode(LEXER_SKIP_TO_ENDR);
		}
#line 3945 "src/asm/parser.c"
    break;

  case 154: /* $@11: %empty  */
#line 1099 "src/asm/parser.y"
                              {
			lexer_ToggleStringExpansion(false);
		}
#line 3953 "src/asm/parser.c"
    break;

  case 155: /* $@12: %empty  */
#line 1101 "src/asm/parser.y"
                       {
			lexer_ToggleStringExpansion(true);
		}
#line 3961 "src/asm/parser.c"
    break;

  case 156: /* @13: %empty  */
#line 1103 "src/asm/parser.y"
                            {
			(yyval.captureTerminated) = lexer_CaptureMacroBody(&captureBody);
		}
#line 3969 "src/asm/parser.c"
    break;

  case 157: /* macrodef: "MACRO" $@11 "identifier" $@12 "newline" @13 endofline  */
#line 1105 "src/asm/parser.y"
                            {
			if ((yyvsp[-1].captureTerminated))
				sym_AddMacro((yyvsp[-4].symName), captureBody.lineNo, captureBody.body,
					     captureBody.size);
		}
#line 3979 "src/asm/parser.c"
    break;

  case 158: /* @14: %empty  */
#line 1110 "src/asm/parser.y"
                                                        {
			(yyval.captureTerminated) = lexer_CaptureMacroBody(&captureBody);
		}
#line 3987 "src/asm/parser.c"
    break;

  case 159: /* macrodef: "label" ":" "MACRO" "newline" @14 endofline  */
#line 1112 "src/asm/parser.y"
                            {
			if ((yyvsp[-1].captureTerminated))
				sym_AddMacro((yyvsp[-5].symName), captureBody.lineNo, captureBody.body,
					     captureBody.size);
		}
#line 3997 "src/asm/parser.c"
    break;

  case 160: /* rsset: "RSSET" uconst  */
#line 1119 "src/asm/parser.y"
                                     { sym_AddVar("_RS", (yyvsp[0].constValue)); }
#line 4003 "src/asm/parser.c"
    break;

  case 161: /* rsreset: "RSRESET"  */
#line 1122 "src/asm/parser.y"
                                { sym_AddVar("_RS", 0); }
#line 4009 "src/asm/parser.c"
    break;

  case 162: /* rs_uconst: %empty  */
#line 1125 "src/asm/parser.y"
                         { (yyval.constValue) = 1; }
#line 4015 "src/asm/parser.c"
    break;

  case 164: /* union: "UNION"  */
#line 1129 "src/asm/parser.y"
                              { sect_StartUnion(); }
#line 4021 "src/asm/parser.c"
    break;

  case 165: /* nextu: "NEXTU"  */
#line 1132 "src/asm/parser.y"
                              { sect_NextUnionMember(); }
#line 4027 "src/asm/parser.c"
    break;

  case 166: /* endu: "ENDU"  */
#line 1135 "src/asm/parser.y"
                             { sect_EndUnion(); }
#line 4033 "src/asm/parser.c"
    break;

  case 167: /* ds: "DS" uconst  */
#line 1138 "src/asm/parser.y"
                                  { sect_Skip((yyvsp[0].constValue), true); }
#line 4039 "src/asm/parser.c"
    break;

  case 168: /* ds: "DS" uconst "," ds_args trailing_comma  */
#line 1139 "src/asm/parser.y"
                                                                 {
			sect_RelBytes((yyvsp[-3].constValue), (yyvsp[-1].dsArgs).args, (yyvsp[-1].dsArgs).nbArgs);
			freeDsArgList(&(yyvsp[-1].dsArgs));
		}
#line 4048 "src/asm/parser.c"
    break;

  case 169: /* ds_args: reloc_8bit  */
#line 1145 "src/asm/parser.y"
                             {
			initDsArgList(&(yyval.dsArgs));
			size_t i = nextDsArgListIndex(&(yyval.dsArgs));

			(yyval.dsArgs).args[i] = (yyvsp[0].expr);
		}
#line 4059 "src/asm/parser.c"
    break;

  case 170: /* ds_args: ds_args "," reloc_8bit  */
#line 1151 "src/asm/parser.y"
                                             {
			size_t i = nextDsArgListIndex(&(yyvsp[-2].dsArgs));

			(yyvsp[-2].dsArgs).args[i] = (yyvsp[0].expr);
			(yyval.dsArgs) = (yyvsp[-2].dsArgs);
		}
#line 4070 "src/asm/parser.c"
    break;

  case 171: /* db: "DB"  */
#line 1159 "src/asm/parser.y"
                           { sect_Skip(1, false); }
#line 4076 "src/asm/parser.c"
    break;

  case 173: /* dw: "DW"  */
#line 1163 "src/asm/parser.y"
                           { sect_Skip(2, false); }
#line 4082 "src/asm/parser.c"
    break;

  case 175: /* dl: "DL"  */
#line 1167 "src/asm/parser.y"
                           { sect_Skip(4, false); }
#line 4088 "src/asm/parser.c"
    break;

  case 177: /* def_equ: def_id "EQU" const  */
#line 1171 "src/asm/parser.y"
                                         { sym_AddEqu((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 4094 "src/asm/parser.c"
    break;

  case 178: /* redef_equ: redef_id "EQU" const  */
#line 1174 "src/asm/parser.y"
                                           { sym_RedefEqu((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 4100 "src/asm/parser.c"
    break;

  case 179: /* def_set: def_id "=" const  */
#line 1177 "src/asm/parser.y"
                                           { sym_AddVar((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 4106 "src/asm/parser.c"
    break;

  case 180: /* def_set: redef_id "=" const  */
#line 1178 "src/asm/parser.y"
                                             { sym_AddVar((yyvsp[-2].symName), (yyvsp[0].constValue)); }
#line 4112 "src/asm/parser.c"
    break;

  case 181: /* def_set: def_id compoundeq const  */
#line 1179 "src/asm/parser.y"
                                          { compoundAssignment((yyvsp[-2].symName), (yyvsp[-1].compoundEqual), (yyvsp[0].constValue)); }
#line 4118 "src/asm/parser.c"
    break;

  case 182: /* def_set: redef_id compoundeq const  */
#line 1180 "src/asm/parser.y"
                                            { compoundAssignment((yyvsp[-2].symName), (yyvsp[-1].compoundEqual), (yyvsp[0].constValue)); }
#line 4124 "src/asm/parser.c"
    break;

  case 183: /* def_set: def_id "SET" const  */
#line 1181 "src/asm/parser.y"
                                         {
			warning(WARNING_OBSOLETE, "`SET` for variables is deprecated; use `=`\n");
			sym_AddVar((yyvsp[-2].symName), (yyvsp[0].constValue));
		}
#line 4133 "src/asm/parser.c"
    break;

  case 184: /* def_set: redef_id "SET" const  */
#line 1185 "src/asm/parser.y"
                                           {
			warning(WARNING_OBSOLETE, "`SET` for variables is deprecated; use `=`\n");
			sym_AddVar((yyvsp[-2].symName), (yyvsp[0].constValue));
		}
#line 4142 "src/asm/parser.c"
    break;

  case 185: /* def_rb: def_id "RB" rs_uconst  */
#line 1191 "src/asm/parser.y"
                                            {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddVar("_RS", sym_GetConstantValue("_RS") + (yyvsp[0].constValue));
		}
#line 4151 "src/asm/parser.c"
    break;

  case 186: /* def_rw: def_id "RW" rs_uconst  */
#line 1197 "src/asm/parser.y"
                                            {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddVar("_RS", sym_GetConstantValue("_RS") + 2 * (yyvsp[0].constValue));
		}
#line 4160 "src/asm/parser.c"
    break;

  case 187: /* def_rl: def_id "rl" rs_uconst  */
#line 1203 "src/asm/parser.y"
                                            {
			sym_AddEqu((yyvsp[-2].symName), sym_GetConstantValue("_RS"));
			sym_AddVar("_RS", sym_GetConstantValue("_RS") + 4 * (yyvsp[0].constValue));
		}
#line 4169 "src/asm/parser.c"
    break;

  case 188: /* def_equs: def_id "EQUS" string  */
#line 1209 "src/asm/parser.y"
                                           { sym_AddString((yyvsp[-2].symName), (yyvsp[0].string)); }
#line 4175 "src/asm/parser.c"
    break;

  case 189: /* redef_equs: redef_id "EQUS" string  */
#line 1212 "src/asm/parser.y"
                                             { sym_RedefString((yyvsp[-2].symName), (yyvsp[0].string)); }
#line 4181 "src/asm/parser.c"
    break;

  case 190: /* $@15: %empty  */
#line 1215 "src/asm/parser.y"
                              {
			lexer_ToggleStringExpansion(false);
		}
#line 4189 "src/asm/parser.c"
    break;

  case 191: /* purge: "PURGE" $@15 purge_list trailing_comma  */
#line 1217 "src/asm/parser.y"
                                            {
			lexer_ToggleStringExpansion(true);
		}
#line 4197 "src/asm/parser.c"
    break;

  case 194: /* purge_list_entry: scoped_id  */
#line 1226 "src/asm/parser.y"
                             { sym_Purge((yyvsp[0].symName)); }
#line 4203 "src/asm/parser.c"
    break;

  case 198: /* export_list_entry: scoped_id  */
#line 1236 "src/asm/parser.y"
                              { sym_Export((yyvsp[0].symName)); }
#line 4209 "src/asm/parser.c"
    break;

  case 199: /* include: label "INCLUDE" string endofline  */
#line 1239 "src/asm/parser.y"
                                                       {
			fstk_RunInclude((yyvsp[-1].string));
			if (failedOnMissingInclude)
				YYACCEPT;
		}
#line 4219 "src/asm/parser.c"
    break;

  case 200: /* incbin: "INCBIN" string  */
#line 1246 "src/asm/parser.y"
                                      {
			sect_BinaryFile((yyvsp[0].string), 0);
			if (failedOnMissingInclude)
				YYACCEPT;
		}
#line 4229 "src/asm/parser.c"
    break;

  case 201: /* incbin: "INCBIN" string "," const  */
#line 1251 "src/asm/parser.y"
                                                    {
			sect_BinaryFile((yyvsp[-2].string), (yyvsp[0].constValue));
			if (failedOnMissingInclude)
				YYACCEPT;
		}
#line 4239 "src/asm/parser.c"
    break;

  case 202: /* incbin: "INCBIN" string "," const "," const  */
#line 1256 "src/asm/parser.y"
                                                                  {
			sect_BinaryFileSlice((yyvsp[-4].string), (yyvsp[-2].constValue), (yyvsp[0].constValue));
			if (failedOnMissingInclude)
				YYACCEPT;
		}
#line 4249 "src/asm/parser.c"
    break;

  case 203: /* charmap: "CHARMAP" string "," const_8bit  */
#line 1263 "src/asm/parser.y"
                                                          {
			charmap_Add((yyvsp[-2].string), (uint8_t)(yyvsp[0].constValue));
		}
#line 4257 "src/asm/parser.c"
    break;

  case 204: /* newcharmap: "NEWCHARMAP" "identifier"  */
#line 1268 "src/asm/parser.y"
                                        { charmap_New((yyvsp[0].symName), NULL); }
#line 4263 "src/asm/parser.c"
    break;

  case 205: /* newcharmap: "NEWCHARMAP" "identifier" "," "identifier"  */
#line 1269 "src/asm/parser.y"
                                                     { charmap_New((yyvsp[-2].symName), (yyvsp[0].symName)); }
#line 4269 "src/asm/parser.c"
    break;

  case 206: /* setcharmap: "SETCHARMAP" "identifier"  */
#line 1272 "src/asm/parser.y"
                                        { charmap_Set((yyvsp[0].symName)); }
#line 4275 "src/asm/parser.c"
    break;

  case 207: /* pushc: "PUSHC"  */
#line 1275 "src/asm/parser.y"
                              { charmap_Push(); }
#line 4281 "src/asm/parser.c"
    break;

  case 208: /* popc: "POPC"  */
#line 1278 "src/asm/parser.y"
                             { charmap_Pop(); }
#line 4287 "src/asm/parser.c"
    break;

  case 210: /* println: "PRINTLN"  */
#line 1284 "src/asm/parser.y"
                                {
			putchar('\n');
			fflush(stdout);
		}
#line 4296 "src/asm/parser.c"
    break;

  case 211: /* println: "PRINTLN" print_exprs trailing_comma  */
#line 1288 "src/asm/parser.y"
                                                           {
			putchar('\n');
			fflush(stdout);
		}
#line 4305 "src/asm/parser.c"
    break;

  case 214: /* print_expr: const_no_str  */
#line 1298 "src/asm/parser.y"
                               { printf("$%" PRIX32, (yyvsp[0].constValue)); }
#line 4311 "src/asm/parser.c"
    break;

  case 215: /* print_expr: string  */
#line 1299 "src/asm/parser.y"
                         { printf("%s", (yyvsp[0].string)); }
#line 4317 "src/asm/parser.c"
    break;

  case 216: /* printt: "PRINTT" string  */
#line 1302 "src/asm/parser.y"
                                      {
			warning(WARNING_OBSOLETE, "`PRINTT` is deprecated; use `PRINT`\n");
			printf("%s", (yyvsp[0].string));
		}
#line 4326 "src/asm/parser.c"
    break;

  case 217: /* printv: "PRINTV" const  */
#line 1308 "src/asm/parser.y"
                                     {
			warning(WARNING_OBSOLETE, "`PRINTV` is deprecated; use `PRINT`\n");
			printf("$%" PRIX32, (yyvsp[0].constValue));
		}
#line 4335 "src/asm/parser.c"
    break;

  case 218: /* printi: "PRINTI" const  */
#line 1314 "src/asm/parser.y"
                                     {
			warning(WARNING_OBSOLETE, "`PRINTI` is deprecated; use `PRINT` with `STRFMT` \"%%d\"\n");
			printf("%" PRId32, (yyvsp[0].constValue));
		}
#line 4344 "src/asm/parser.c"
    break;

  case 219: /* printf: "PRINTF" const  */
#line 1320 "src/asm/parser.y"
                                     {
			warning(WARNING_OBSOLETE, "`PRINTF` is deprecated; use `PRINT` with `STRFMT` \"%%f\"\n");
			fix_Print((yyvsp[0].constValue));
		}
#line 4353 "src/asm/parser.c"
    break;

  case 220: /* const_3bit: const  */
#line 1326 "src/asm/parser.y"
                        {
			int32_t value = (yyvsp[0].constValue);

			if ((value < 0) || (value > 7)) {
				error("Immediate value must be 3-bit\n");
				(yyval.constValue) = 0;
			} else {
				(yyval.constValue) = value & 0x7;
			}
		}
#line 4368 "src/asm/parser.c"
    break;

  case 223: /* constlist_8bit_entry: reloc_8bit_no_str  */
#line 1342 "src/asm/parser.y"
                                         {
			sect_RelByte(&(yyvsp[0].expr), 0);
		}
#line 4376 "src/asm/parser.c"
    break;

  case 224: /* constlist_8bit_entry: string  */
#line 1345 "src/asm/parser.y"
                         {
			uint8_t *output = malloc(strlen((yyvsp[0].string))); /* Cannot be larger than that */
			size_t length = charmap_Convert((yyvsp[0].string), output);

			sect_AbsByteGroup(output, length);
			free(output);
		}
#line 4388 "src/asm/parser.c"
    break;

  case 227: /* constlist_16bit_entry: reloc_16bit_no_str  */
#line 1358 "src/asm/parser.y"
                                           {
			sect_RelWord(&(yyvsp[0].expr), 0);
		}
#line 4396 "src/asm/parser.c"
    break;

  case 228: /* constlist_16bit_entry: string  */
#line 1361 "src/asm/parser.y"
                         {
			uint8_t *output = malloc(strlen((yyvsp[0].string))); /* Cannot be larger than that */
			size_t length = charmap_Convert((yyvsp[0].string), output);

			sect_AbsWordGroup(output, length);
			free(output);
		}
#line 4408 "src/asm/parser.c"
    break;

  case 231: /* constlist_32bit_entry: relocexpr_no_str  */
#line 1374 "src/asm/parser.y"
                                         {
			sect_RelLong(&(yyvsp[0].expr), 0);
		}
#line 4416 "src/asm/parser.c"
    break;

  case 232: /* constlist_32bit_entry: string  */
#line 1377 "src/asm/parser.y"
                         {
			// Charmaps cannot increase the length of a string
			uint8_t *output = malloc(strlen((yyvsp[0].string)));
			size_t length = charmap_Convert((yyvsp[0].string), output);

			sect_AbsLongGroup(output, length);
			free(output);
		}
#line 4429 "src/asm/parser.c"
    break;

  case 233: /* reloc_8bit: relocexpr  */
#line 1387 "src/asm/parser.y"
                            {
			rpn_CheckNBit(&(yyvsp[0].expr), 8);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4438 "src/asm/parser.c"
    break;

  case 234: /* reloc_8bit_no_str: relocexpr_no_str  */
#line 1393 "src/asm/parser.y"
                                     {
			rpn_CheckNBit(&(yyvsp[0].expr), 8);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4447 "src/asm/parser.c"
    break;

  case 235: /* reloc_8bit_offset: "+" relocexpr  */
#line 1399 "src/asm/parser.y"
                                       {
			rpn_CheckNBit(&(yyvsp[0].expr), 8);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4456 "src/asm/parser.c"
    break;

  case 236: /* reloc_8bit_offset: "-" relocexpr  */
#line 1403 "src/asm/parser.y"
                                     {
			rpn_UNNEG(&(yyval.expr), &(yyvsp[0].expr));
			rpn_CheckNBit(&(yyval.expr), 8);
		}
#line 4465 "src/asm/parser.c"
    break;

  case 237: /* reloc_16bit: relocexpr  */
#line 1409 "src/asm/parser.y"
                            {
			rpn_CheckNBit(&(yyvsp[0].expr), 16);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4474 "src/asm/parser.c"
    break;

  case 238: /* reloc_16bit_no_str: relocexpr_no_str  */
#line 1415 "src/asm/parser.y"
                                      {
			rpn_CheckNBit(&(yyvsp[0].expr), 16);
			(yyval.expr) = (yyvsp[0].expr);
		}
#line 4483 "src/asm/parser.c"
    break;

  case 240: /* relocexpr: string  */
#line 1423 "src/asm/parser.y"
                         {
			// Charmaps cannot increase the length of a string
			uint8_t *output = malloc(strlen((yyvsp[0].string)));
			uint32_t length = charmap_Convert((yyvsp[0].string), output);
			uint32_t r = str2int2(output, length);

			free(output);
			rpn_Number(&(yyval.expr), r);
		}
#line 4497 "src/asm/parser.c"
    break;

  case 241: /* relocexpr_no_str: scoped_anon_id  */
#line 1434 "src/asm/parser.y"
                                  { rpn_Symbol(&(yyval.expr), (yyvsp[0].symName)); }
#line 4503 "src/asm/parser.c"
    break;

  case 242: /* relocexpr_no_str: "number"  */
#line 1435 "src/asm/parser.y"
                           { rpn_Number(&(yyval.expr), (yyvsp[0].constValue)); }
#line 4509 "src/asm/parser.c"
    break;

  case 243: /* relocexpr_no_str: "!" relocexpr  */
#line 1436 "src/asm/parser.y"
                                                    {
			rpn_LOGNOT(&(yyval.expr), &(yyvsp[0].expr));
		}
#line 4517 "src/asm/parser.c"
    break;

  case 244: /* relocexpr_no_str: relocexpr "||" relocexpr  */
#line 1439 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGOR, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4525 "src/asm/parser.c"
    break;

  case 245: /* relocexpr_no_str: relocexpr "&&" relocexpr  */
#line 1442 "src/asm/parser.y"
                                                    {
			rpn_BinaryOp(RPN_LOGAND, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4533 "src/asm/parser.c"
    break;

  case 246: /* relocexpr_no_str: relocexpr "==" relocexpr  */
#line 1445 "src/asm/parser.y"
                                                    {
			rpn_BinaryOp(RPN_LOGEQ, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4541 "src/asm/parser.c"
    break;

  case 247: /* relocexpr_no_str: relocexpr ">" relocexpr  */
#line 1448 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGGT, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4549 "src/asm/parser.c"
    break;

  case 248: /* relocexpr_no_str: relocexpr "<" relocexpr  */
#line 1451 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGLT, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4557 "src/asm/parser.c"
    break;

  case 249: /* relocexpr_no_str: relocexpr ">=" relocexpr  */
#line 1454 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGGE, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4565 "src/asm/parser.c"
    break;

  case 250: /* relocexpr_no_str: relocexpr "<=" relocexpr  */
#line 1457 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGLE, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4573 "src/asm/parser.c"
    break;

  case 251: /* relocexpr_no_str: relocexpr "!=" relocexpr  */
#line 1460 "src/asm/parser.y"
                                                   {
			rpn_BinaryOp(RPN_LOGNE, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4581 "src/asm/parser.c"
    break;

  case 252: /* relocexpr_no_str: relocexpr "+" relocexpr  */
#line 1463 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_ADD, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4589 "src/asm/parser.c"
    break;

  case 253: /* relocexpr_no_str: relocexpr "-" relocexpr  */
#line 1466 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_SUB, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4597 "src/asm/parser.c"
    break;

  case 254: /* relocexpr_no_str: relocexpr "^" relocexpr  */
#line 1469 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_XOR, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4605 "src/asm/parser.c"
    break;

  case 255: /* relocexpr_no_str: relocexpr "|" relocexpr  */
#line 1472 "src/asm/parser.y"
                                              {
			rpn_BinaryOp(RPN_OR, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4613 "src/asm/parser.c"
    break;

  case 256: /* relocexpr_no_str: relocexpr "&" relocexpr  */
#line 1475 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_AND, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4621 "src/asm/parser.c"
    break;

  case 257: /* relocexpr_no_str: relocexpr "<<" relocexpr  */
#line 1478 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_SHL, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4629 "src/asm/parser.c"
    break;

  case 258: /* relocexpr_no_str: relocexpr ">>" relocexpr  */
#line 1481 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_SHR, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4637 "src/asm/parser.c"
    break;

  case 259: /* relocexpr_no_str: relocexpr "*" relocexpr  */
#line 1484 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_MUL, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4645 "src/asm/parser.c"
    break;

  case 260: /* relocexpr_no_str: relocexpr "/" relocexpr  */
#line 1487 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_DIV, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4653 "src/asm/parser.c"
    break;

  case 261: /* relocexpr_no_str: relocexpr "%" relocexpr  */
#line 1490 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_MOD, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4661 "src/asm/parser.c"
    break;

  case 262: /* relocexpr_no_str: relocexpr "**" relocexpr  */
#line 1493 "src/asm/parser.y"
                                               {
			rpn_BinaryOp(RPN_EXP, &(yyval.expr), &(yyvsp[-2].expr), &(yyvsp[0].expr));
		}
#line 4669 "src/asm/parser.c"
    break;

  case 263: /* relocexpr_no_str: "+" relocexpr  */
#line 1496 "src/asm/parser.y"
                                               { (yyval.expr) = (yyvsp[0].expr); }
#line 4675 "src/asm/parser.c"
    break;

  case 264: /* relocexpr_no_str: "-" relocexpr  */
#line 1497 "src/asm/parser.y"
                                               { rpn_UNNEG(&(yyval.expr), &(yyvsp[0].expr)); }
#line 4681 "src/asm/parser.c"
    break;

  case 265: /* relocexpr_no_str: "~" relocexpr  */
#line 1498 "src/asm/parser.y"
                                               { rpn_UNNOT(&(yyval.expr), &(yyvsp[0].expr)); }
#line 4687 "src/asm/parser.c"
    break;

  case 266: /* relocexpr_no_str: "HIGH" "(" relocexpr ")"  */
#line 1499 "src/asm/parser.y"
                                                        { rpn_HIGH(&(yyval.expr), &(yyvsp[-1].expr)); }
#line 4693 "src/asm/parser.c"
    break;

  case 267: /* relocexpr_no_str: "LOW" "(" relocexpr ")"  */
#line 1500 "src/asm/parser.y"
                                                       { rpn_LOW(&(yyval.expr), &(yyvsp[-1].expr)); }
#line 4699 "src/asm/parser.c"
    break;

  case 268: /* relocexpr_no_str: "ISCONST" "(" relocexpr ")"  */
#line 1501 "src/asm/parser.y"
                                                           { rpn_ISCONST(&(yyval.expr), &(yyvsp[-1].expr)); }
#line 4705 "src/asm/parser.c"
    break;

  case 269: /* relocexpr_no_str: "BANK" "(" scoped_anon_id ")"  */
#line 1502 "src/asm/parser.y"
                                                             {
			// '@' is also a T_ID; it is handled here
			rpn_BankSymbol(&(yyval.expr), (yyvsp[-1].symName));
		}
#line 4714 "src/asm/parser.c"
    break;

  case 270: /* relocexpr_no_str: "BANK" "(" string ")"  */
#line 1506 "src/asm/parser.y"
                                                     { rpn_BankSection(&(yyval.expr), (yyvsp[-1].string)); }
#line 4720 "src/asm/parser.c"
    break;

  case 271: /* relocexpr_no_str: "SIZEOF" "(" string ")"  */
#line 1507 "src/asm/parser.y"
                                                       { rpn_SizeOfSection(&(yyval.expr), (yyvsp[-1].string)); }
#line 4726 "src/asm/parser.c"
    break;

  case 272: /* relocexpr_no_str: "STARTOF" "(" string ")"  */
#line 1508 "src/asm/parser.y"
                                                        { rpn_StartOfSection(&(yyval.expr), (yyvsp[-1].string)); }
#line 4732 "src/asm/parser.c"
    break;

  case 273: /* $@16: %empty  */
#line 1509 "src/asm/parser.y"
                           {
			lexer_ToggleStringExpansion(false);
		}
#line 4740 "src/asm/parser.c"
    break;

  case 274: /* relocexpr_no_str: "DEF" $@16 "(" scoped_anon_id ")"  */
#line 1511 "src/asm/parser.y"
                                                   {
			struct Symbol const *sym = sym_FindScopedSymbol((yyvsp[-1].symName));

			rpn_Number(&(yyval.expr), !!sym);

			lexer_ToggleStringExpansion(true);
		}
#line 4752 "src/asm/parser.c"
    break;

  case 275: /* relocexpr_no_str: "ROUND" "(" const ")"  */
#line 1518 "src/asm/parser.y"
                                                     {
			rpn_Number(&(yyval.expr), fix_Round((yyvsp[-1].constValue)));
		}
#line 4760 "src/asm/parser.c"
    break;

  case 276: /* relocexpr_no_str: "CEIL" "(" const ")"  */
#line 1521 "src/asm/parser.y"
                                                    {
			rpn_Number(&(yyval.expr), fix_Ceil((yyvsp[-1].constValue)));
		}
#line 4768 "src/asm/parser.c"
    break;

  case 277: /* relocexpr_no_str: "FLOOR" "(" const ")"  */
#line 1524 "src/asm/parser.y"
                                                     {
			rpn_Number(&(yyval.expr), fix_Floor((yyvsp[-1].constValue)));
		}
#line 4776 "src/asm/parser.c"
    break;

  case 278: /* relocexpr_no_str: "FDIV" "(" const "," const ")"  */
#line 1527 "src/asm/parser.y"
                                                                  {
			rpn_Number(&(yyval.expr), fix_Div((yyvsp[-3].constValue), (yyvsp[-1].constValue)));
		}
#line 4784 "src/asm/parser.c"
    break;

  case 279: /* relocexpr_no_str: "FMUL" "(" const "," const ")"  */
#line 1530 "src/asm/parser.y"
                                                                  {
			rpn_Number(&(yyval.expr), fix_Mul((yyvsp[-3].constValue), (yyvsp[-1].constValue)));
		}
#line 4792 "src/asm/parser.c"
    break;

  case 280: /* relocexpr_no_str: "POW" "(" const "," const ")"  */
#line 1533 "src/asm/parser.y"
                                                                 {
			rpn_Number(&(yyval.expr), fix_Pow((yyvsp[-3].constValue), (yyvsp[-1].constValue)));
		}
#line 4800 "src/asm/parser.c"
    break;

  case 281: /* relocexpr_no_str: "LOG" "(" const "," const ")"  */
#line 1536 "src/asm/parser.y"
                                                                 {
			rpn_Number(&(yyval.expr), fix_Log((yyvsp[-3].constValue), (yyvsp[-1].constValue)));
		}
#line 4808 "src/asm/parser.c"
    break;

  case 282: /* relocexpr_no_str: "SIN" "(" const ")"  */
#line 1539 "src/asm/parser.y"
                                                   {
			rpn_Number(&(yyval.expr), fix_Sin((yyvsp[-1].constValue)));
		}
#line 4816 "src/asm/parser.c"
    break;

  case 283: /* relocexpr_no_str: "COS" "(" const ")"  */
#line 1542 "src/asm/parser.y"
                                                   {
			rpn_Number(&(yyval.expr), fix_Cos((yyvsp[-1].constValue)));
		}
#line 4824 "src/asm/parser.c"
    break;

  case 284: /* relocexpr_no_str: "TAN" "(" const ")"  */
#line 1545 "src/asm/parser.y"
                                                   {
			rpn_Number(&(yyval.expr), fix_Tan((yyvsp[-1].constValue)));
		}
#line 4832 "src/asm/parser.c"
    break;

  case 285: /* relocexpr_no_str: "ASIN" "(" const ")"  */
#line 1548 "src/asm/parser.y"
                                                    {
			rpn_Number(&(yyval.expr), fix_ASin((yyvsp[-1].constValue)));
		}
#line 4840 "src/asm/parser.c"
    break;

  case 286: /* relocexpr_no_str: "ACOS" "(" const ")"  */
#line 1551 "src/asm/parser.y"
                                                    {
			rpn_Number(&(yyval.expr), fix_ACos((yyvsp[-1].constValue)));
		}
#line 4848 "src/asm/parser.c"
    break;

  case 287: /* relocexpr_no_str: "ATAN" "(" const ")"  */
#line 1554 "src/asm/parser.y"
                                                    {
			rpn_Number(&(yyval.expr), fix_ATan((yyvsp[-1].constValue)));
		}
#line 4856 "src/asm/parser.c"
    break;

  case 288: /* relocexpr_no_str: "ATAN2" "(" const "," const ")"  */
#line 1557 "src/asm/parser.y"
                                                                   {
			rpn_Number(&(yyval.expr), fix_ATan2((yyvsp[-3].constValue), (yyvsp[-1].constValue)));
		}
#line 4864 "src/asm/parser.c"
    break;

  case 289: /* relocexpr_no_str: "STRCMP" "(" string "," string ")"  */
#line 1560 "src/asm/parser.y"
                                                                      {
			rpn_Number(&(yyval.expr), strcmp((yyvsp[-3].string), (yyvsp[-1].string)));
		}
#line 4872 "src/asm/parser.c"
    break;

  case 290: /* relocexpr_no_str: "STRIN" "(" string "," string ")"  */
#line 1563 "src/asm/parser.y"
                                                                     {
			char const *p = strstr((yyvsp[-3].string), (yyvsp[-1].string));

			rpn_Number(&(yyval.expr), p ? p - (yyvsp[-3].string) + 1 : 0);
		}
#line 4882 "src/asm/parser.c"
    break;

  case 291: /* relocexpr_no_str: "STRRIN" "(" string "," string ")"  */
#line 1568 "src/asm/parser.y"
                                                                      {
			char const *p = strrstr((yyvsp[-3].string), (yyvsp[-1].string));

			rpn_Number(&(yyval.expr), p ? p - (yyvsp[-3].string) + 1 : 0);
		}
#line 4892 "src/asm/parser.c"
    break;

  case 292: /* relocexpr_no_str: "STRLEN" "(" string ")"  */
#line 1573 "src/asm/parser.y"
                                                       {
			rpn_Number(&(yyval.expr), strlenUTF8((yyvsp[-1].string)));
		}
#line 4900 "src/asm/parser.c"
    break;

  case 293: /* relocexpr_no_str: "CHARLEN" "(" string ")"  */
#line 1576 "src/asm/parser.y"
                                                        {
			rpn_Number(&(yyval.expr), charlenUTF8((yyvsp[-1].string)));
		}
#line 4908 "src/asm/parser.c"
    break;

  case 294: /* relocexpr_no_str: "(" relocexpr ")"  */
#line 1579 "src/asm/parser.y"
                                              { (yyval.expr) = (yyvsp[-1].expr); }
#line 4914 "src/asm/parser.c"
    break;

  case 295: /* uconst: const  */
#line 1582 "src/asm/parser.y"
                        {
			(yyval.constValue) = (yyvsp[0].constValue);
			if ((yyval.constValue) < 0)
				fatalerror("Constant mustn't be negative: %d\n", (yyvsp[0].constValue));
		}
#line 4924 "src/asm/parser.c"
    break;

  case 296: /* const: relocexpr  */
#line 1589 "src/asm/parser.y"
                            { (yyval.constValue) = rpn_GetConstVal(&(yyvsp[0].expr)); }
#line 4930 "src/asm/parser.c"
    break;

  case 297: /* const_no_str: relocexpr_no_str  */
#line 1592 "src/asm/parser.y"
                                   { (yyval.constValue) = rpn_GetConstVal(&(yyvsp[0].expr)); }
#line 4936 "src/asm/parser.c"
    break;

  case 298: /* const_8bit: reloc_8bit  */
#line 1595 "src/asm/parser.y"
                             { (yyval.constValue) = rpn_GetConstVal(&(yyvsp[0].expr)); }
#line 4942 "src/asm/parser.c"
    break;

  case 300: /* string: "STRSUB" "(" string "," const "," uconst ")"  */
#line 1599 "src/asm/parser.y"
                                                                                    {
			size_t len = strlenUTF8((yyvsp[-5].string));
			uint32_t pos = adjustNegativePos((yyvsp[-3].constValue), len, "STRSUB");

			strsubUTF8((yyval.string), sizeof((yyval.string)), (yyvsp[-5].string), pos, (yyvsp[-1].constValue));
		}
#line 4953 "src/asm/parser.c"
    break;

  case 301: /* string: "STRSUB" "(" string "," const ")"  */
#line 1605 "src/asm/parser.y"
                                                                     {
			size_t len = strlenUTF8((yyvsp[-3].string));
			uint32_t pos = adjustNegativePos((yyvsp[-1].constValue), len, "STRSUB");

			strsubUTF8((yyval.string), sizeof((yyval.string)), (yyvsp[-3].string), pos, pos > len ? 0 : len + 1 - pos);
		}
#line 4964 "src/asm/parser.c"
    break;

  case 302: /* string: "CHARSUB" "(" string "," const ")"  */
#line 1611 "src/asm/parser.y"
                                                                      {
			size_t len = charlenUTF8((yyvsp[-3].string));
			uint32_t pos = adjustNegativePos((yyvsp[-1].constValue), len, "CHARSUB");

			charsubUTF8((yyval.string), (yyvsp[-3].string), pos);
		}
#line 4975 "src/asm/parser.c"
    break;

  case 303: /* string: "STRCAT" "(" ")"  */
#line 1617 "src/asm/parser.y"
                                                {
			(yyval.string)[0] = '\0';
		}
#line 4983 "src/asm/parser.c"
    break;

  case 304: /* string: "STRCAT" "(" strcat_args ")"  */
#line 1620 "src/asm/parser.y"
                                                            {
			strcpy((yyval.string), (yyvsp[-1].string));
		}
#line 4991 "src/asm/parser.c"
    break;

  case 305: /* string: "STRUPR" "(" string ")"  */
#line 1623 "src/asm/parser.y"
                                                       {
			upperstring((yyval.string), (yyvsp[-1].string));
		}
#line 4999 "src/asm/parser.c"
    break;

  case 306: /* string: "STRLWR" "(" string ")"  */
#line 1626 "src/asm/parser.y"
                                                       {
			lowerstring((yyval.string), (yyvsp[-1].string));
		}
#line 5007 "src/asm/parser.c"
    break;

  case 307: /* string: "STRRPL" "(" string "," string "," string ")"  */
#line 1629 "src/asm/parser.y"
                                                                                     {
			strrpl((yyval.string), sizeof((yyval.string)), (yyvsp[-5].string), (yyvsp[-3].string), (yyvsp[-1].string));
		}
#line 5015 "src/asm/parser.c"
    break;

  case 308: /* string: "STRFMT" "(" strfmt_args ")"  */
#line 1632 "src/asm/parser.y"
                                                            {
			strfmt((yyval.string), sizeof((yyval.string)), (yyvsp[-1].strfmtArgs).format, (yyvsp[-1].strfmtArgs).nbArgs, (yyvsp[-1].strfmtArgs).args);
			freeStrFmtArgList(&(yyvsp[-1].strfmtArgs));
		}
#line 5024 "src/asm/parser.c"
    break;

  case 310: /* strcat_args: strcat_args "," string  */
#line 1639 "src/asm/parser.y"
                                             {
			int ret = snprintf((yyval.string), sizeof((yyval.string)), "%s%s", (yyvsp[-2].string), (yyvsp[0].string));

			if (ret == -1)
				fatalerror("snprintf error in STRCAT: %s\n", strerror(errno));
			else if ((unsigned int)ret >= sizeof((yyval.string)))
				warning(WARNING_LONG_STR, "STRCAT: String too long '%s%s'\n",
					(yyvsp[-2].string), (yyvsp[0].string));
		}
#line 5038 "src/asm/parser.c"
    break;

  case 311: /* strfmt_args: string strfmt_va_args  */
#line 1650 "src/asm/parser.y"
                                        {
			(yyval.strfmtArgs).format = strdup((yyvsp[-1].string));
			(yyval.strfmtArgs).capacity = (yyvsp[0].strfmtArgs).capacity;
			(yyval.strfmtArgs).nbArgs = (yyvsp[0].strfmtArgs).nbArgs;
			(yyval.strfmtArgs).args = (yyvsp[0].strfmtArgs).args;
		}
#line 5049 "src/asm/parser.c"
    break;

  case 312: /* strfmt_va_args: %empty  */
#line 1658 "src/asm/parser.y"
                         {
			initStrFmtArgList(&(yyval.strfmtArgs));
		}
#line 5057 "src/asm/parser.c"
    break;

  case 313: /* strfmt_va_args: strfmt_va_args "," const_no_str  */
#line 1661 "src/asm/parser.y"
                                                      {
			size_t i = nextStrFmtArgListIndex(&(yyvsp[-2].strfmtArgs));

			(yyvsp[-2].strfmtArgs).args[i].number = (yyvsp[0].constValue);
			(yyvsp[-2].strfmtArgs).args[i].isNumeric = true;
			(yyval.strfmtArgs) = (yyvsp[-2].strfmtArgs);
		}
#line 5069 "src/asm/parser.c"
    break;

  case 314: /* strfmt_va_args: strfmt_va_args "," string  */
#line 1668 "src/asm/parser.y"
                                                {
			size_t i = nextStrFmtArgListIndex(&(yyvsp[-2].strfmtArgs));

			(yyvsp[-2].strfmtArgs).args[i].string = strdup((yyvsp[0].string));
			(yyvsp[-2].strfmtArgs).args[i].isNumeric = false;
			(yyval.strfmtArgs) = (yyvsp[-2].strfmtArgs);
		}
#line 5081 "src/asm/parser.c"
    break;

  case 315: /* section: "SECTION" sectmod string "," sectiontype sectorg sectattrs  */
#line 1677 "src/asm/parser.y"
                                                                                     {
			sect_NewSection((yyvsp[-4].string), (yyvsp[-2].constValue), (yyvsp[-1].constValue), &(yyvsp[0].sectSpec), (yyvsp[-5].sectMod));
		}
#line 5089 "src/asm/parser.c"
    break;

  case 316: /* sectmod: %empty  */
#line 1682 "src/asm/parser.y"
                         { (yyval.sectMod) = SECTION_NORMAL; }
#line 5095 "src/asm/parser.c"
    break;

  case 317: /* sectmod: "UNION"  */
#line 1683 "src/asm/parser.y"
                              { (yyval.sectMod) = SECTION_UNION; }
#line 5101 "src/asm/parser.c"
    break;

  case 318: /* sectmod: "FRAGMENT"  */
#line 1684 "src/asm/parser.y"
                                 { (yyval.sectMod) = SECTION_FRAGMENT; }
#line 5107 "src/asm/parser.c"
    break;

  case 319: /* sectiontype: "WRAM0"  */
#line 1687 "src/asm/parser.y"
                               { (yyval.constValue) = SECTTYPE_WRAM0; }
#line 5113 "src/asm/parser.c"
    break;

  case 320: /* sectiontype: "VRAM"  */
#line 1688 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_VRAM; }
#line 5119 "src/asm/parser.c"
    break;

  case 321: /* sectiontype: "ROMX"  */
#line 1689 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_ROMX; }
#line 5125 "src/asm/parser.c"
    break;

  case 322: /* sectiontype: "ROM0"  */
#line 1690 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_ROM0; }
#line 5131 "src/asm/parser.c"
    break;

  case 323: /* sectiontype: "HRAM"  */
#line 1691 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_HRAM; }
#line 5137 "src/asm/parser.c"
    break;

  case 324: /* sectiontype: "WRAMX"  */
#line 1692 "src/asm/parser.y"
                               { (yyval.constValue) = SECTTYPE_WRAMX; }
#line 5143 "src/asm/parser.c"
    break;

  case 325: /* sectiontype: "SRAM"  */
#line 1693 "src/asm/parser.y"
                              { (yyval.constValue) = SECTTYPE_SRAM; }
#line 5149 "src/asm/parser.c"
    break;

  case 326: /* sectiontype: "OAM"  */
#line 1694 "src/asm/parser.y"
                             { (yyval.constValue) = SECTTYPE_OAM; }
#line 5155 "src/asm/parser.c"
    break;

  case 327: /* sectorg: %empty  */
#line 1697 "src/asm/parser.y"
                         { (yyval.constValue) = -1; }
#line 5161 "src/asm/parser.c"
    break;

  case 328: /* sectorg: "[" uconst "]"  */
#line 1698 "src/asm/parser.y"
                                           {
			if ((yyvsp[-1].constValue) < 0 || (yyvsp[-1].constValue) >= 0x10000) {
				error("Address $%x is not 16-bit\n", (yyvsp[-1].constValue));
				(yyval.constValue) = -1;
			} else {
				(yyval.constValue) = (yyvsp[-1].constValue);
			}
		}
#line 5174 "src/asm/parser.c"
    break;

  case 329: /* sectattrs: %empty  */
#line 1708 "src/asm/parser.y"
                         {
			(yyval.sectSpec).alignment = 0;
			(yyval.sectSpec).alignOfs = 0;
			(yyval.sectSpec).bank = -1;
		}
#line 5184 "src/asm/parser.c"
    break;

  case 330: /* sectattrs: sectattrs "," "ALIGN" "[" uconst "]"  */
#line 1713 "src/asm/parser.y"
                                                                        {
			(yyval.sectSpec).alignment = (yyvsp[-1].constValue);
		}
#line 5192 "src/asm/parser.c"
    break;

  case 331: /* sectattrs: sectattrs "," "ALIGN" "[" uconst "," uconst "]"  */
#line 1716 "src/asm/parser.y"
                                                                                       {
			(yyval.sectSpec).alignment = (yyvsp[-3].constValue);
			(yyval.sectSpec).alignOfs = (yyvsp[-1].constValue);
		}
#line 5201 "src/asm/parser.c"
    break;

  case 332: /* sectattrs: sectattrs "," "BANK" "[" uconst "]"  */
#line 1720 "src/asm/parser.y"
                                                                       {
			/* We cannot check the validity of this now */
			(yyval.sectSpec).bank = (yyvsp[-1].constValue);
		}
#line 5210 "src/asm/parser.c"
    break;

  case 379: /* z80_adc: "adc" op_a_n  */
#line 1775 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xCE);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5219 "src/asm/parser.c"
    break;

  case 380: /* z80_adc: "adc" op_a_r  */
#line 1779 "src/asm/parser.y"
                                   { sect_AbsByte(0x88 | (yyvsp[0].constValue)); }
#line 5225 "src/asm/parser.c"
    break;

  case 381: /* z80_add: "add" op_a_n  */
#line 1782 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xC6);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5234 "src/asm/parser.c"
    break;

  case 382: /* z80_add: "add" op_a_r  */
#line 1786 "src/asm/parser.y"
                                   { sect_AbsByte(0x80 | (yyvsp[0].constValue)); }
#line 5240 "src/asm/parser.c"
    break;

  case 383: /* z80_add: "add" "hl" "," reg_ss  */
#line 1787 "src/asm/parser.y"
                                                     { sect_AbsByte(0x09 | ((yyvsp[0].constValue) << 4)); }
#line 5246 "src/asm/parser.c"
    break;

  case 384: /* z80_add: "add" "sp" "," reloc_8bit  */
#line 1788 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0xE8);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5255 "src/asm/parser.c"
    break;

  case 385: /* z80_and: "and" op_a_n  */
#line 1795 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xE6);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5264 "src/asm/parser.c"
    break;

  case 386: /* z80_and: "and" op_a_r  */
#line 1799 "src/asm/parser.y"
                                   { sect_AbsByte(0xA0 | (yyvsp[0].constValue)); }
#line 5270 "src/asm/parser.c"
    break;

  case 387: /* z80_bit: "bit" const_3bit "," reg_r  */
#line 1802 "src/asm/parser.y"
                                                     {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x40 | ((yyvsp[-2].constValue) << 3) | (yyvsp[0].constValue));
		}
#line 5279 "src/asm/parser.c"
    break;

  case 388: /* z80_call: "call" reloc_16bit  */
#line 1808 "src/asm/parser.y"
                                         {
			sect_AbsByte(0xCD);
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5288 "src/asm/parser.c"
    break;

  case 389: /* z80_call: "call" ccode_expr "," reloc_16bit  */
#line 1812 "src/asm/parser.y"
                                                            {
			sect_AbsByte(0xC4 | ((yyvsp[-2].constValue) << 3));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5297 "src/asm/parser.c"
    break;

  case 390: /* z80_ccf: "ccf"  */
#line 1818 "src/asm/parser.y"
                            { sect_AbsByte(0x3F); }
#line 5303 "src/asm/parser.c"
    break;

  case 391: /* z80_cp: "cp" op_a_n  */
#line 1821 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xFE);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5312 "src/asm/parser.c"
    break;

  case 392: /* z80_cp: "cp" op_a_r  */
#line 1825 "src/asm/parser.y"
                                  { sect_AbsByte(0xB8 | (yyvsp[0].constValue)); }
#line 5318 "src/asm/parser.c"
    break;

  case 393: /* z80_cpl: "cpl"  */
#line 1828 "src/asm/parser.y"
                            { sect_AbsByte(0x2F); }
#line 5324 "src/asm/parser.c"
    break;

  case 394: /* z80_daa: "daa"  */
#line 1831 "src/asm/parser.y"
                            { sect_AbsByte(0x27); }
#line 5330 "src/asm/parser.c"
    break;

  case 395: /* z80_dec: "dec" reg_r  */
#line 1834 "src/asm/parser.y"
                                  { sect_AbsByte(0x05 | ((yyvsp[0].constValue) << 3)); }
#line 5336 "src/asm/parser.c"
    break;

  case 396: /* z80_dec: "dec" reg_ss  */
#line 1835 "src/asm/parser.y"
                                   { sect_AbsByte(0x0B | ((yyvsp[0].constValue) << 4)); }
#line 5342 "src/asm/parser.c"
    break;

  case 397: /* z80_di: "di"  */
#line 1838 "src/asm/parser.y"
                           { sect_AbsByte(0xF3); }
#line 5348 "src/asm/parser.c"
    break;

  case 398: /* z80_ei: "ei"  */
#line 1841 "src/asm/parser.y"
                           { sect_AbsByte(0xFB); }
#line 5354 "src/asm/parser.c"
    break;

  case 399: /* z80_halt: "halt"  */
#line 1844 "src/asm/parser.y"
                             {
			sect_AbsByte(0x76);
			if (haltnop)
				sect_AbsByte(0x00);
		}
#line 5364 "src/asm/parser.c"
    break;

  case 400: /* z80_inc: "inc" reg_r  */
#line 1851 "src/asm/parser.y"
                                  { sect_AbsByte(0x04 | ((yyvsp[0].constValue) << 3)); }
#line 5370 "src/asm/parser.c"
    break;

  case 401: /* z80_inc: "inc" reg_ss  */
#line 1852 "src/asm/parser.y"
                                   { sect_AbsByte(0x03 | ((yyvsp[0].constValue) << 4)); }
#line 5376 "src/asm/parser.c"
    break;

  case 402: /* z80_jp: "jp" reloc_16bit  */
#line 1855 "src/asm/parser.y"
                                       {
			sect_AbsByte(0xC3);
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5385 "src/asm/parser.c"
    break;

  case 403: /* z80_jp: "jp" ccode_expr "," reloc_16bit  */
#line 1859 "src/asm/parser.y"
                                                          {
			sect_AbsByte(0xC2 | ((yyvsp[-2].constValue) << 3));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5394 "src/asm/parser.c"
    break;

  case 404: /* z80_jp: "jp" "hl"  */
#line 1863 "src/asm/parser.y"
                                     {
			sect_AbsByte(0xE9);
		}
#line 5402 "src/asm/parser.c"
    break;

  case 405: /* z80_jr: "jr" reloc_16bit  */
#line 1868 "src/asm/parser.y"
                                       {
			sect_AbsByte(0x18);
			sect_PCRelByte(&(yyvsp[0].expr), 1);
		}
#line 5411 "src/asm/parser.c"
    break;

  case 406: /* z80_jr: "jr" ccode_expr "," reloc_16bit  */
#line 1872 "src/asm/parser.y"
                                                          {
			sect_AbsByte(0x20 | ((yyvsp[-2].constValue) << 3));
			sect_PCRelByte(&(yyvsp[0].expr), 1);
		}
#line 5420 "src/asm/parser.c"
    break;

  case 407: /* z80_ldi: "ldi" "[" "hl" "]" "," T_MODE_A  */
#line 1878 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0x02 | (2 << 4));
		}
#line 5428 "src/asm/parser.c"
    break;

  case 408: /* z80_ldi: "ldi" T_MODE_A "," "[" "hl" "]"  */
#line 1881 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0x0A | (2 << 4));
		}
#line 5436 "src/asm/parser.c"
    break;

  case 409: /* z80_ldd: "ldd" "[" "hl" "]" "," T_MODE_A  */
#line 1886 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0x02 | (3 << 4));
		}
#line 5444 "src/asm/parser.c"
    break;

  case 410: /* z80_ldd: "ldd" T_MODE_A "," "[" "hl" "]"  */
#line 1889 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0x0A | (3 << 4));
		}
#line 5452 "src/asm/parser.c"
    break;

  case 411: /* z80_ldio: "ldh" T_MODE_A "," op_mem_ind  */
#line 1894 "src/asm/parser.y"
                                                        {
			rpn_CheckHRAM(&(yyvsp[0].expr), &(yyvsp[0].expr));

			sect_AbsByte(0xF0);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5463 "src/asm/parser.c"
    break;

  case 412: /* z80_ldio: "ldh" op_mem_ind "," T_MODE_A  */
#line 1900 "src/asm/parser.y"
                                                        {
			rpn_CheckHRAM(&(yyvsp[-2].expr), &(yyvsp[-2].expr));

			sect_AbsByte(0xE0);
			sect_RelByte(&(yyvsp[-2].expr), 1);
		}
#line 5474 "src/asm/parser.c"
    break;

  case 413: /* z80_ldio: "ldh" T_MODE_A "," c_ind  */
#line 1906 "src/asm/parser.y"
                                                   {
			sect_AbsByte(0xF2);
		}
#line 5482 "src/asm/parser.c"
    break;

  case 414: /* z80_ldio: "ldh" c_ind "," T_MODE_A  */
#line 1909 "src/asm/parser.y"
                                                   {
			sect_AbsByte(0xE2);
		}
#line 5490 "src/asm/parser.c"
    break;

  case 416: /* c_ind: "[" relocexpr "+" T_MODE_C "]"  */
#line 1915 "src/asm/parser.y"
                                                                {
			if (!rpn_isKnown(&(yyvsp[-3].expr)) || (yyvsp[-3].expr).val != 0xff00)
				error("Expected constant expression equal to $FF00 for \"$ff00+c\"\n");
		}
#line 5499 "src/asm/parser.c"
    break;

  case 425: /* z80_ld_hl: "ld" "hl" "," "sp" reloc_8bit_offset  */
#line 1931 "src/asm/parser.y"
                                                                         {
			sect_AbsByte(0xF8);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5508 "src/asm/parser.c"
    break;

  case 426: /* z80_ld_hl: "ld" "hl" "," reloc_16bit  */
#line 1935 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0x01 | (REG_HL << 4));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5517 "src/asm/parser.c"
    break;

  case 427: /* z80_ld_sp: "ld" "sp" "," "hl"  */
#line 1941 "src/asm/parser.y"
                                                       { sect_AbsByte(0xF9); }
#line 5523 "src/asm/parser.c"
    break;

  case 428: /* z80_ld_sp: "ld" "sp" "," reloc_16bit  */
#line 1942 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0x01 | (REG_SP << 4));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5532 "src/asm/parser.c"
    break;

  case 429: /* z80_ld_mem: "ld" op_mem_ind "," "sp"  */
#line 1948 "src/asm/parser.y"
                                                        {
			sect_AbsByte(0x08);
			sect_RelWord(&(yyvsp[-2].expr), 1);
		}
#line 5541 "src/asm/parser.c"
    break;

  case 430: /* z80_ld_mem: "ld" op_mem_ind "," T_MODE_A  */
#line 1952 "src/asm/parser.y"
                                                       {
			if (optimizeLoads && rpn_isKnown(&(yyvsp[-2].expr))
			 && (yyvsp[-2].expr).val >= 0xFF00) {
				sect_AbsByte(0xE0);
				sect_AbsByte((yyvsp[-2].expr).val & 0xFF);
				rpn_Free(&(yyvsp[-2].expr));
			} else {
				sect_AbsByte(0xEA);
				sect_RelWord(&(yyvsp[-2].expr), 1);
			}
		}
#line 5557 "src/asm/parser.c"
    break;

  case 431: /* z80_ld_cind: "ld" c_ind "," T_MODE_A  */
#line 1965 "src/asm/parser.y"
                                                  {
			sect_AbsByte(0xE2);
		}
#line 5565 "src/asm/parser.c"
    break;

  case 432: /* z80_ld_rr: "ld" reg_rr "," T_MODE_A  */
#line 1970 "src/asm/parser.y"
                                                   {
			sect_AbsByte(0x02 | ((yyvsp[-2].constValue) << 4));
		}
#line 5573 "src/asm/parser.c"
    break;

  case 433: /* z80_ld_r: "ld" reg_r "," reloc_8bit  */
#line 1975 "src/asm/parser.y"
                                                    {
			sect_AbsByte(0x06 | ((yyvsp[-2].constValue) << 3));
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5582 "src/asm/parser.c"
    break;

  case 434: /* z80_ld_r: "ld" reg_r "," reg_r  */
#line 1979 "src/asm/parser.y"
                                               {
			if (((yyvsp[-2].constValue) == REG_HL_IND) && ((yyvsp[0].constValue) == REG_HL_IND))
				error("LD [HL],[HL] not a valid instruction\n");
			else
				sect_AbsByte(0x40 | ((yyvsp[-2].constValue) << 3) | (yyvsp[0].constValue));
		}
#line 5593 "src/asm/parser.c"
    break;

  case 435: /* z80_ld_a: "ld" reg_r "," c_ind  */
#line 1987 "src/asm/parser.y"
                                               {
			if ((yyvsp[-2].constValue) == REG_A)
				sect_AbsByte(0xF2);
			else
				error("Destination operand must be A\n");
		}
#line 5604 "src/asm/parser.c"
    break;

  case 436: /* z80_ld_a: "ld" reg_r "," reg_rr  */
#line 1993 "src/asm/parser.y"
                                                {
			if ((yyvsp[-2].constValue) == REG_A)
				sect_AbsByte(0x0A | ((yyvsp[0].constValue) << 4));
			else
				error("Destination operand must be A\n");
		}
#line 5615 "src/asm/parser.c"
    break;

  case 437: /* z80_ld_a: "ld" reg_r "," op_mem_ind  */
#line 1999 "src/asm/parser.y"
                                                    {
			if ((yyvsp[-2].constValue) == REG_A) {
				if (optimizeLoads && rpn_isKnown(&(yyvsp[0].expr))
				 && (yyvsp[0].expr).val >= 0xFF00) {
					sect_AbsByte(0xF0);
					sect_AbsByte((yyvsp[0].expr).val & 0xFF);
					rpn_Free(&(yyvsp[0].expr));
				} else {
					sect_AbsByte(0xFA);
					sect_RelWord(&(yyvsp[0].expr), 1);
				}
			} else {
				error("Destination operand must be A\n");
				rpn_Free(&(yyvsp[0].expr));
			}
		}
#line 5636 "src/asm/parser.c"
    break;

  case 438: /* z80_ld_ss: "ld" "bc" "," reloc_16bit  */
#line 2017 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0x01 | (REG_BC << 4));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5645 "src/asm/parser.c"
    break;

  case 439: /* z80_ld_ss: "ld" "de" "," reloc_16bit  */
#line 2021 "src/asm/parser.y"
                                                         {
			sect_AbsByte(0x01 | (REG_DE << 4));
			sect_RelWord(&(yyvsp[0].expr), 1);
		}
#line 5654 "src/asm/parser.c"
    break;

  case 440: /* z80_nop: "nop"  */
#line 2031 "src/asm/parser.y"
                            { sect_AbsByte(0x00); }
#line 5660 "src/asm/parser.c"
    break;

  case 441: /* z80_or: "or" op_a_n  */
#line 2034 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xF6);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5669 "src/asm/parser.c"
    break;

  case 442: /* z80_or: "or" op_a_r  */
#line 2038 "src/asm/parser.y"
                                  { sect_AbsByte(0xB0 | (yyvsp[0].constValue)); }
#line 5675 "src/asm/parser.c"
    break;

  case 443: /* z80_pop: "pop" reg_tt  */
#line 2041 "src/asm/parser.y"
                                   { sect_AbsByte(0xC1 | ((yyvsp[0].constValue) << 4)); }
#line 5681 "src/asm/parser.c"
    break;

  case 444: /* z80_push: "push" reg_tt  */
#line 2044 "src/asm/parser.y"
                                    { sect_AbsByte(0xC5 | ((yyvsp[0].constValue) << 4)); }
#line 5687 "src/asm/parser.c"
    break;

  case 445: /* z80_res: "res" const_3bit "," reg_r  */
#line 2047 "src/asm/parser.y"
                                                     {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x80 | ((yyvsp[-2].constValue) << 3) | (yyvsp[0].constValue));
		}
#line 5696 "src/asm/parser.c"
    break;

  case 446: /* z80_ret: "ret"  */
#line 2053 "src/asm/parser.y"
                            { sect_AbsByte(0xC9); }
#line 5702 "src/asm/parser.c"
    break;

  case 447: /* z80_ret: "ret" ccode_expr  */
#line 2054 "src/asm/parser.y"
                                       { sect_AbsByte(0xC0 | ((yyvsp[0].constValue) << 3)); }
#line 5708 "src/asm/parser.c"
    break;

  case 448: /* z80_reti: "reti"  */
#line 2057 "src/asm/parser.y"
                             { sect_AbsByte(0xD9); }
#line 5714 "src/asm/parser.c"
    break;

  case 449: /* z80_rl: "rl" reg_r  */
#line 2060 "src/asm/parser.y"
                                 {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x10 | (yyvsp[0].constValue));
		}
#line 5723 "src/asm/parser.c"
    break;

  case 450: /* z80_rla: "rla"  */
#line 2066 "src/asm/parser.y"
                            { sect_AbsByte(0x17); }
#line 5729 "src/asm/parser.c"
    break;

  case 451: /* z80_rlc: "rlc" reg_r  */
#line 2069 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x00 | (yyvsp[0].constValue));
		}
#line 5738 "src/asm/parser.c"
    break;

  case 452: /* z80_rlca: "rlca"  */
#line 2075 "src/asm/parser.y"
                             { sect_AbsByte(0x07); }
#line 5744 "src/asm/parser.c"
    break;

  case 453: /* z80_rr: "rr" reg_r  */
#line 2078 "src/asm/parser.y"
                                 {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x18 | (yyvsp[0].constValue));
		}
#line 5753 "src/asm/parser.c"
    break;

  case 454: /* z80_rra: "rra"  */
#line 2084 "src/asm/parser.y"
                            { sect_AbsByte(0x1F); }
#line 5759 "src/asm/parser.c"
    break;

  case 455: /* z80_rrc: "rrc" reg_r  */
#line 2087 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x08 | (yyvsp[0].constValue));
		}
#line 5768 "src/asm/parser.c"
    break;

  case 456: /* z80_rrca: "rrca"  */
#line 2093 "src/asm/parser.y"
                             { sect_AbsByte(0x0F); }
#line 5774 "src/asm/parser.c"
    break;

  case 457: /* z80_rst: "rst" reloc_8bit  */
#line 2096 "src/asm/parser.y"
                                       {
			rpn_CheckRST(&(yyvsp[0].expr), &(yyvsp[0].expr));
			if (!rpn_isKnown(&(yyvsp[0].expr)))
				sect_RelByte(&(yyvsp[0].expr), 0);
			else
				sect_AbsByte(0xC7 | (yyvsp[0].expr).val);
			rpn_Free(&(yyvsp[0].expr));
		}
#line 5787 "src/asm/parser.c"
    break;

  case 458: /* z80_sbc: "sbc" op_a_n  */
#line 2106 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xDE);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5796 "src/asm/parser.c"
    break;

  case 459: /* z80_sbc: "sbc" op_a_r  */
#line 2110 "src/asm/parser.y"
                                   { sect_AbsByte(0x98 | (yyvsp[0].constValue)); }
#line 5802 "src/asm/parser.c"
    break;

  case 460: /* z80_scf: "scf"  */
#line 2113 "src/asm/parser.y"
                            { sect_AbsByte(0x37); }
#line 5808 "src/asm/parser.c"
    break;

  case 461: /* z80_set: "SET" const_3bit "," reg_r  */
#line 2116 "src/asm/parser.y"
                                                     {
			sect_AbsByte(0xCB);
			sect_AbsByte(0xC0 | ((yyvsp[-2].constValue) << 3) | (yyvsp[0].constValue));
		}
#line 5817 "src/asm/parser.c"
    break;

  case 462: /* z80_sla: "sla" reg_r  */
#line 2122 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x20 | (yyvsp[0].constValue));
		}
#line 5826 "src/asm/parser.c"
    break;

  case 463: /* z80_sra: "sra" reg_r  */
#line 2128 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x28 | (yyvsp[0].constValue));
		}
#line 5835 "src/asm/parser.c"
    break;

  case 464: /* z80_srl: "srl" reg_r  */
#line 2134 "src/asm/parser.y"
                                  {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x38 | (yyvsp[0].constValue));
		}
#line 5844 "src/asm/parser.c"
    break;

  case 465: /* z80_stop: "stop"  */
#line 2140 "src/asm/parser.y"
                             {
			sect_AbsByte(0x10);
			sect_AbsByte(0x00);
		}
#line 5853 "src/asm/parser.c"
    break;

  case 466: /* z80_stop: "stop" reloc_8bit  */
#line 2144 "src/asm/parser.y"
                                        {
			sect_AbsByte(0x10);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5862 "src/asm/parser.c"
    break;

  case 467: /* z80_sub: "sub" op_a_n  */
#line 2150 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xD6);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5871 "src/asm/parser.c"
    break;

  case 468: /* z80_sub: "sub" op_a_r  */
#line 2154 "src/asm/parser.y"
                                   { sect_AbsByte(0x90 | (yyvsp[0].constValue)); }
#line 5877 "src/asm/parser.c"
    break;

  case 469: /* z80_swap: "swap" reg_r  */
#line 2157 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xCB);
			sect_AbsByte(0x30 | (yyvsp[0].constValue));
		}
#line 5886 "src/asm/parser.c"
    break;

  case 470: /* z80_xor: "xor" op_a_n  */
#line 2163 "src/asm/parser.y"
                                   {
			sect_AbsByte(0xEE);
			sect_RelByte(&(yyvsp[0].expr), 1);
		}
#line 5895 "src/asm/parser.c"
    break;

  case 471: /* z80_xor: "xor" op_a_r  */
#line 2167 "src/asm/parser.y"
                                   { sect_AbsByte(0xA8 | (yyvsp[0].constValue)); }
#line 5901 "src/asm/parser.c"
    break;

  case 472: /* op_mem_ind: "[" reloc_16bit "]"  */
#line 2170 "src/asm/parser.y"
                                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 5907 "src/asm/parser.c"
    break;

  case 474: /* op_a_r: T_MODE_A "," reg_r  */
#line 2174 "src/asm/parser.y"
                                         { (yyval.constValue) = (yyvsp[0].constValue); }
#line 5913 "src/asm/parser.c"
    break;

  case 476: /* op_a_n: T_MODE_A "," reloc_8bit  */
#line 2178 "src/asm/parser.y"
                                              { (yyval.expr) = (yyvsp[0].expr); }
#line 5919 "src/asm/parser.c"
    break;

  case 492: /* ccode_expr: "!" ccode_expr  */
#line 2210 "src/asm/parser.y"
                                           {
			(yyval.constValue) = (yyvsp[0].constValue) ^ 1;
		}
#line 5927 "src/asm/parser.c"
    break;

  case 493: /* ccode: "nz"  */
#line 2215 "src/asm/parser.y"
                          { (yyval.constValue) = CC_NZ; }
#line 5933 "src/asm/parser.c"
    break;

  case 494: /* ccode: "z"  */
#line 2216 "src/asm/parser.y"
                         { (yyval.constValue) = CC_Z; }
#line 5939 "src/asm/parser.c"
    break;

  case 495: /* ccode: "nc"  */
#line 2217 "src/asm/parser.y"
                          { (yyval.constValue) = CC_NC; }
#line 5945 "src/asm/parser.c"
    break;

  case 496: /* ccode: "c"  */
#line 2218 "src/asm/parser.y"
                            { (yyval.constValue) = CC_C; }
#line 5951 "src/asm/parser.c"
    break;

  case 497: /* reg_r: T_MODE_B  */
#line 2221 "src/asm/parser.y"
                           { (yyval.constValue) = REG_B; }
#line 5957 "src/asm/parser.c"
    break;

  case 498: /* reg_r: T_MODE_C  */
#line 2222 "src/asm/parser.y"
                           { (yyval.constValue) = REG_C; }
#line 5963 "src/asm/parser.c"
    break;

  case 499: /* reg_r: T_MODE_D  */
#line 2223 "src/asm/parser.y"
                           { (yyval.constValue) = REG_D; }
#line 5969 "src/asm/parser.c"
    break;

  case 500: /* reg_r: T_MODE_E  */
#line 2224 "src/asm/parser.y"
                           { (yyval.constValue) = REG_E; }
#line 5975 "src/asm/parser.c"
    break;

  case 501: /* reg_r: T_MODE_H  */
#line 2225 "src/asm/parser.y"
                           { (yyval.constValue) = REG_H; }
#line 5981 "src/asm/parser.c"
    break;

  case 502: /* reg_r: T_MODE_L  */
#line 2226 "src/asm/parser.y"
                           { (yyval.constValue) = REG_L; }
#line 5987 "src/asm/parser.c"
    break;

  case 503: /* reg_r: "[" "hl" "]"  */
#line 2227 "src/asm/parser.y"
                                              { (yyval.constValue) = REG_HL_IND; }
#line 5993 "src/asm/parser.c"
    break;

  case 504: /* reg_r: T_MODE_A  */
#line 2228 "src/asm/parser.y"
                           { (yyval.constValue) = REG_A; }
#line 5999 "src/asm/parser.c"
    break;

  case 505: /* reg_tt: "bc"  */
#line 2231 "src/asm/parser.y"
                            { (yyval.constValue) = REG_BC; }
#line 6005 "src/asm/parser.c"
    break;

  case 506: /* reg_tt: "de"  */
#line 2232 "src/asm/parser.y"
                            { (yyval.constValue) = REG_DE; }
#line 6011 "src/asm/parser.c"
    break;

  case 507: /* reg_tt: "hl"  */
#line 2233 "src/asm/parser.y"
                            { (yyval.constValue) = REG_HL; }
#line 6017 "src/asm/parser.c"
    break;

  case 508: /* reg_tt: "af"  */
#line 2234 "src/asm/parser.y"
                            { (yyval.constValue) = REG_AF; }
#line 6023 "src/asm/parser.c"
    break;

  case 509: /* reg_ss: "bc"  */
#line 2237 "src/asm/parser.y"
                            { (yyval.constValue) = REG_BC; }
#line 6029 "src/asm/parser.c"
    break;

  case 510: /* reg_ss: "de"  */
#line 2238 "src/asm/parser.y"
                            { (yyval.constValue) = REG_DE; }
#line 6035 "src/asm/parser.c"
    break;

  case 511: /* reg_ss: "hl"  */
#line 2239 "src/asm/parser.y"
                            { (yyval.constValue) = REG_HL; }
#line 6041 "src/asm/parser.c"
    break;

  case 512: /* reg_ss: "sp"  */
#line 2240 "src/asm/parser.y"
                            { (yyval.constValue) = REG_SP; }
#line 6047 "src/asm/parser.c"
    break;

  case 513: /* reg_rr: "[" "bc" "]"  */
#line 2243 "src/asm/parser.y"
                                              { (yyval.constValue) = REG_BC_IND; }
#line 6053 "src/asm/parser.c"
    break;

  case 514: /* reg_rr: "[" "de" "]"  */
#line 2244 "src/asm/parser.y"
                                              { (yyval.constValue) = REG_DE_IND; }
#line 6059 "src/asm/parser.c"
    break;

  case 515: /* reg_rr: hl_ind_inc  */
#line 2245 "src/asm/parser.y"
                             { (yyval.constValue) = REG_HL_INDINC; }
#line 6065 "src/asm/parser.c"
    break;

  case 516: /* reg_rr: hl_ind_dec  */
#line 2246 "src/asm/parser.y"
                             { (yyval.constValue) = REG_HL_INDDEC; }
#line 6071 "src/asm/parser.c"
    break;


#line 6075 "src/asm/parser.c"

        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yyesa, &yyes, &yyes_capacity, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != YYEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= T_EOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == T_EOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2257 "src/asm/parser.y"

